#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5 + 5;

unsigned long long sums[MAXN];

int n;
vector <pair<int, int> > G[MAXN];

bool used[MAXN];

int from, to;
bool found = 0;

int temporary = 0;

int d[MAXN];

vector <int> c;

vector < vector <int> > ds(MAXN);

void dfs(int s, int sum = 0)
{
    for (int i = 0; i < G[s].size(); i++)
    {
        int v = G[s][i].first;
        int tg = G[s][i].second;

        if (used[v]) continue;
        used[v] = 1;

        d[v] = d[s] + tg;

        c.push_back(v);

        ds[v] = c;

        dfs(v, sum + tg);

        c.pop_back();
    }
}


int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i < n; i++)
    {
        int x, y, l;
        cin >> x >> y >> l;

        G[x].push_back({y, l});
        G[y].push_back({x, l});
    }

    for (int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        memset(d, 0, sizeof(d));
        ds.clear();
        c.clear();
        c.push_back(i);
        temporary = 0;
        from = i;
//        to = j;

        found = 0;
        used[from] = 1;

        dfs(from);

        for (int j = i; j <= n; j++)
        {
            for (int k = 0; k < ds[j].size(); k++)
            {
                sums[ds[j][k]] += d[j];
            }
        }
    }

    for (int i = 1; i <= n; i++)
    {
        cout << sums[i] << endl;
    }

    return 0;
}
/**
6
1 2 3
1 4 5
3 4 7
4 5 9
4 6 10

---
107
61
67
182
75
79

*/



