#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

long long fast_pow10(int p)
{
    if (p <= 1) return 10;
    long long pw = fast_pow10(p/2);
    if (p%2 == 0) return pw * pw;

    return pw * pw * 10;
}

long long fast_pow(unsigned long long base, unsigned long long pw, unsigned long long mod)
{
    if (pw <= 1) return base;
    unsigned long long c = fast_pow(base, pw/2, mod) % mod;
    if (pw%2 == 0) return (c * c) % mod;

    return ((c * c) % mod * base) % mod;
}

void solve()
{
    unsigned long long a, b;
    int k;
    cin >> a >> b >> k;

    unsigned long long mod = fast_pow10(k);

    a %= mod;

    unsigned long long p = fast_pow(a, b, mod);

    cout << p / (mod / 10) << endl;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
/**
1
42 7 7


9
*/
