#include <bits/stdc++.h>
#define endl '\n'
#define LL unsigned long long int
using namespace std;

int brc = 0;

string mult(string a, string b)
{
    if (a.size() > brc) a = a.substr(a.size() - brc, brc);
    if (b.size() > brc) b = b.substr(b.size() - brc, brc);

    while (a.size() < b.size()) a = "0" + a;
    while (b.size() < a.size()) b = "0" + b;

    string res(a.size() * 2, '0');

    int br = 0;


    for (int i = a.size() - 1; i >= 0; i--)
    {
        LL ost = 0;

        for (int j = b.size() - 1; j >= 0; j--)
        {
            int tmp = (a[i] - '0') * (b[j] - '0') + res[i+j+1] - '0' + ost;

            res[i+j+1] = (char)(tmp%10 + '0');

            ost = tmp/10;

//            cerr << i << " " << a[i] << " " << endl;
//            cerr << j << " " << b[j] << " " << endl;
        }
        if (ost) res[i] = (char)(ost + '0');

        br++;
        if (br > brc) return res;
    }

    if (res.size() > brc) res = res.substr(res.size() - brc, brc);

    return res;
}

string fast_pow(string base, LL pw)
{
    if (pw <= 1) return base;
    string c = fast_pow(base, pw/2);
    if (pw%2 == 0) return mult(c, c);

//    cerr << c << " " << mult(c, c) << " " << mult(mult(c, c), base) << endl;

    return mult(mult(c, c), base);
}

void solve()
{
    string a;
    LL b;
    int k;
    cin >> a >> b >> k;

    brc = k;

    string p = fast_pow(a, b);

//    string p = "1";
//    for (int i = 1; i <= b; i++)
//    {
//        p = mult(p, a);
//    }

//    cerr << p << endl;

    reverse(p.begin(), p.end());
    cout << p[k-1] << endl;

}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

//    cerr << 42*42 << endl;

//    string a;
//    string b;
//    cin >> a >> b;
//    cerr << mult(a, b) << endl;

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
/**
1
42 7 7

9

1
1000000000000000000
1000000000000000000
1000

*/
