#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e5+5;
struct edge
{
    int v;
    long long w;
    long long pos;
    edge() {}
    edge(int a,long long b,long long c)
    {
        v=a;
        w=b;
        pos=c;
    }
};
int n;
vector<edge>adj[MAXN];
int root=1;
int brch[MAXN]={0};
long long allpos[MAXN]={0};
long long up[MAXN]={0};
int dfs1(int cur,int par)
{
    int res=1;
    for(int i=0;i<adj[cur].size();i++)
    {
        if(adj[cur][i].v==par)continue;
        res+=dfs1(adj[cur][i].v,cur);
    }
    brch[cur]=res;
    return res;
}
long long dfs2(int cur,int par)
{
    long long res=0;
    for(int i=0;i<adj[cur].size();i++)
    {
        if(adj[cur][i].v==par)continue;
        adj[cur][i].pos=dfs2(adj[cur][i].v,cur)+adj[cur][i].w*brch[adj[cur][i].v];
        res+=adj[cur][i].pos;
        //cout<<cur<<" "<<adj[cur][i].v<<": "<<adj[cur][i].pos<<endl;
    }
    allpos[cur]=res;
    return res;
}
void dfs3(int cur,int par,long long cur_w,long long cur_pos)
{
    if(par!=-1)
    {
        up[cur]=(allpos[par]-cur_pos+up[par])+cur_w*(n-brch[cur]);
    }
    for(int i=0;i<adj[cur].size();i++)
    {
        if(adj[cur][i].v==par)continue;
        dfs3(adj[cur][i].v,cur,adj[cur][i].w,adj[cur][i].pos);
    }
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n;
for(int i=1;i<n;i++)
{
    int u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back(edge(v,w,0));
    adj[v].push_back(edge(u,w,0));
}
for(int i=1;i<=n;i++)
{
    if(adj[i].size()>1){root=i;break;}
}
dfs1(root,-1);
//for(int i=1;i<=n;i++)cout<<brch[i]<<endl;
dfs2(root,-1);
//for(int i=1;i<=n;i++)cout<<allpos[i]<<endl;
up[root]=0;
dfs3(root,-1,0,0);
//for(int i=1;i<=n;i++)cout<<up[i]<<endl;
long long ans=0;
for(int i=1;i<=n;i++)
{
    ans=0;
    ans=ans+up[i]*brch[i];
    for(int j=0;j<adj[i].size();j++)
    {
        ans=ans+adj[i][j].pos*(n-brch[adj[i][j].v]);
    }
    cout<<ans<<endl;
}
return 0;
}
