#include <iostream>
using namespace std;
#define endl '\n'
const long long mod=1e18;
const long long syst=1e9;
int MAXC;
long long ans[128];
void mult(long long a[], long long b[], long long d[]) {
    long long c, pl, cur;
    long long res[MAXC];
    for (int i=0;i<MAXC;i++) res[i]=0;
    for (int i=0;i<MAXC;i++) {
        pl=c=0;
        if (a[i]==0) continue;
        for (int j=0;i+j<MAXC;j++) {
            cur=a[i]*b[j]+c;
            if (cur>syst) c=cur/syst;
            else c=0;
            cur%=syst;
            cur=res[i+j]+cur+pl;
            if (cur>syst) pl=cur/syst;
            else pl=0;
            res[i+j]=cur%syst;
        }
    }
    for (int i=0;i<MAXC;i++) d[i]=res[i];
}
void mult_num(long long a[], long long b, long long res[]) {
    long long c[MAXC];
    int br=0;
    while (b>0) {
        c[br]=b%syst;
        br++;
        b/=syst;
    }
    for (int i=br;i<MAXC;i++) c[i]=0;
    mult(c,a,res);
}
void stepen(long long a, long long b, long long res[]) {
    if (b==0) {
        res[0]=1;
        for (int i=1;i<MAXC;i++) res[i]=0;
        return;
    }
    if (b%2==0) {
        stepen(a,b/2,res);
        mult(res,res,res);
        return;
    }
    stepen(a,b-1,res);
    mult_num(res,a,res);
}
int find_cif(int k) {
    int f=k%9;
    for (int i=0;i<f;i++) ans[MAXC-1]/=10;
    return ans[MAXC-1]%10;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, k;
    long long a, b;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> a >> b >> k;
        k--;
        MAXC=k/9+1;
        stepen(a,b,ans);
        cout << find_cif(k) << endl;
    }
    return 0;
}
/**
2
42 7 10
42 7 11
**/
