#include <stdio.h>
#include <stdlib.h>

#define ll long long

ll abs_(ll n){
	if(n < 0) return -n;
	return n;
}

ll get_num(ll left, ll right){
	ll temp = right;
	ll right_len;
	ll result = left;
	for(int i = 0; temp != 0; i++){
		temp /= 10;
		result *= 10;
	}
	return result + right;
}

ll sum(ll n, ll k){
	ll result = 0;
	for(int i = -n; i <= n; i++){
		if(abs_(i) == abs_(k) || i == 0) continue;
		ll left = i - k;	
		if(get_num(abs_(left), abs_(i)) <= n) result++; 
	}
	return result;
}

int divisible(int num, int div){
	return num % div == 0;
}

ll mul(ll n, ll k){
	ll result = 0;
	for(int i = 1; i < n; i++){
		if(!divisible(k, i)) continue;
		ll left = k / i;	
		if(get_num(left, i) <= n) result++; 
	}
	return result;
}

ll div_(ll n, ll k){
	ll result = 0;
	for(int i = 2; i < n; i++){
		if(k * i > n) break;
		ll left = k * i;
		if(get_num(left, i) <= n) result++;
	}
	return result;
}

ll solve(ll n, ll k){
	ll result = 0;
	if(k <= n) result++;
	result += sum(n, k);
	//result += sub(n, k);
	result += mul(n, k);
	result += div_(n, k);
	return result;
}

int main(){
	ll n, k;
	scanf("%lld %lld", &n, &k);
	printf("%lld", solve(n, abs_(k)));
	return 0;
}
