#include <iostream>
#include <vector>
using namespace std;

const int tenpow[7] = {1, 10, 100, 1000, 10000, 100000, 1000000};

const int ERR = 1000000000;

int N, K;

const int maxc = 5;
const int maxn = 1000000 + 2;
vector<int> ncif;

vector<int> razdrobi(int ch) {
    vector<int> otg;

    while (true) {
        int ost = ch % 10;
        otg.push_back(ost);
        ch = ch / 10;
        if (ch == 0) break;
    }

    vector<int> rev;
    for (int i = otg.size() - 1; i >= 0; i--) {
        rev.push_back(otg[i]);
    }

    return rev;
}

int brcif(int ch) {
    int otg = 0;
    while (true) {
        otg++;
        ch = ch / 10;
        if (ch == 0) break;
    }

    return otg;
}

struct D {
    int dqsno;
    char zn;
    int lqvo;
};

int sm(D d) {
    if (d.zn == 'q') {
        if (d.dqsno != 0) return d.dqsno;
        else return d.lqvo;
    }

    if (d.zn == '+') {
        return d.lqvo + d.dqsno;
    }
    else if (d.zn == '-') {
        return d.lqvo - d.dqsno;
    }
    else if (d.zn == '*') {
        return d.lqvo * d.dqsno;
    }
    else if (d.zn == '/') {
        if (d.dqsno == 0) return ERR;

        if (d.lqvo % d.dqsno != 0) return ERR;

        return d.lqvo / d.dqsno;
    }
    else if (d.zn == '|') {
        if (d.dqsno < 0) return ERR;

        bool minus = false;
        if (d.lqvo < 0) {
            d.lqvo = -d.lqvo;
            minus = true;
        }

        int l = brcif(d.dqsno);
        int otg = d.lqvo * tenpow[l] + d.dqsno;

        if (minus) otg = -otg;
        return otg;
    }
}

const char znaci[5] = {'+', '-', '*', '/', '|'};

bool shtastl[maxn];

int f(D predno, int cif, bool svobodno, int chislodosega) {
    if (predno.lqvo == ERR || predno.dqsno == ERR) return 0;

    if (cif == ncif.size()) {
        if (sm(predno) == K && shtastl[chislodosega] == false) {
            //cout << "!" << chislodosega << endl;

            shtastl[chislodosega] = true;
            return 1;
        }
        else return 0;
    }

	int br = 0;

    if (svobodno == false) {
        for (int i = 0; i < ncif[cif]; i++) {
            for (int z = 0; z < 5; z++) {
                D seg1, seg2;

                seg1.lqvo = sm(predno);
                seg1.zn = znaci[z];
                seg1.dqsno = i;

                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); // + +
                seg1.lqvo = -seg1.lqvo; // - +
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.lqvo = -seg1.lqvo;
                seg1.dqsno = -seg1.dqsno; // + -
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.dqsno = -seg1.dqsno;
                seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo; // - -
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo;

                seg2.lqvo = predno.lqvo;
                seg2.zn = predno.zn;
                D d; d.lqvo = predno.dqsno; d.zn = znaci[z]; d.dqsno = i;
                seg2.dqsno = sm(d);

                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); // + +
                seg2.lqvo = -seg2.lqvo; // - +
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.lqvo = -seg2.lqvo;
                seg2.dqsno = -seg2.dqsno; // + -
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.dqsno = -seg2.dqsno;
                seg2.dqsno = -seg2.dqsno; seg1.lqvo = -seg2.lqvo; // - -
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.dqsno = -seg2.dqsno; seg2.lqvo = -seg2.lqvo;
            }
        }

        { // na granicata

            for (int z = 0; z < 5; z++) {
                D seg1, seg2;

                seg1.lqvo = sm(predno);
                seg1.zn = znaci[z];
                seg1.dqsno = ncif[cif];

                br = br + f(seg1, cif + 1, false, chislodosega * 10 + ncif[cif]); // + +
                seg1.lqvo = -seg1.lqvo; // - +
                br = br + f(seg1, cif + 1, false, chislodosega * 10 + ncif[cif]); seg1.lqvo = -seg1.lqvo;
                seg1.dqsno = -seg1.dqsno; // + -
                br = br + f(seg1, cif + 1, false, chislodosega * 10 + ncif[cif]); seg1.dqsno = -seg1.dqsno;
                seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo; // - -
                br = br + f(seg1, cif + 1, false, chislodosega * 10 + ncif[cif]); seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo;

                seg2.lqvo = predno.lqvo;
                seg2.zn = predno.zn;
                D d; d.lqvo = predno.dqsno; d.zn = znaci[z]; d.dqsno = ncif[cif];
                seg2.dqsno = sm(d);

                br = br + f(seg2, cif + 1, false, chislodosega * 10 + ncif[cif]); // + +
                seg2.lqvo = -seg2.lqvo; // - +
                br = br + f(seg2, cif + 1, false, chislodosega * 10 + ncif[cif]); seg2.lqvo = -seg2.lqvo;
                seg2.dqsno = -seg2.dqsno; // + -
                br = br + f(seg2, cif + 1, false, chislodosega * 10 + ncif[cif]); seg2.dqsno = -seg2.dqsno;
                seg2.dqsno = -seg2.dqsno; seg1.lqvo = -seg2.lqvo; // - -
                br = br + f(seg2, cif + 1, false, chislodosega * 10 + ncif[cif]); seg2.dqsno = -seg2.dqsno; seg2.lqvo = -seg2.lqvo;
            }
        }
    }
    else {
        for (int i = 0; i <= 9; i++) {
            for (int z = 0; z < 5; z++) {
                D seg1, seg2;

                seg1.lqvo = sm(predno);
                seg1.zn = znaci[z];
                seg1.dqsno = i;

                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); // + +
                seg1.lqvo = -seg1.lqvo; // - +
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.lqvo = -seg1.lqvo;
                seg1.dqsno = -seg1.dqsno; // + -
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.dqsno = -seg1.dqsno;
                seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo; // - -
                br = br + f(seg1, cif + 1, true, chislodosega * 10 + i); seg1.dqsno = -seg1.dqsno; seg1.lqvo = -seg1.lqvo;

                seg2.lqvo = predno.lqvo;
                seg2.zn = predno.zn;
                D d; d.lqvo = predno.dqsno; d.zn = znaci[z]; d.dqsno = i;
                seg2.dqsno = sm(d);

                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); // + +
                seg2.lqvo = -seg2.lqvo; // - +
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.lqvo = -seg2.lqvo;
                seg2.dqsno = -seg2.dqsno; // + -
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.dqsno = -seg2.dqsno;
                seg2.dqsno = -seg2.dqsno; seg1.lqvo = -seg2.lqvo; // - -
                br = br + f(seg2, cif + 1, true, chislodosega * 10 + i); seg2.dqsno = -seg2.dqsno; seg2.lqvo = -seg2.lqvo;
            }
        }
    }

    return br;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    cin >> N >> K;
    ncif = razdrobi(N);

    int br = 0;
    D nach; nach.lqvo = 0; nach.dqsno = 0; nach.zn = 'q';
    br = br + f(nach, 0, false, 0);

    cout << br;

    return 0;
}