#include<iostream>
#include<vector>

using namespace std;

const int MAX = 1e5 + 1;

vector<int> e[MAX];
vector<int> ls[MAX];
vector<int> path;
int n;

long long dist[MAX];
bool vis[MAX];

void rec(int start, long long length_so_far)
{
    path.push_back(start);
    vis[start] = true;
    if(length_so_far)
    {
        for (int node: path)
            dist[node] += length_so_far;
    }

    for(int i = 0;i < e[start].size();i++)
    {
        if(!vis[e[start][i]])
            rec(e[start][i], length_so_far + ls[start][i]);
    }
    vis[start] = false;
    path.pop_back();///toi shte bude posleden nqma za kakvo da se pritesnqvame
}

void call(int mid_edge)
{
    rec(mid_edge, 0);
    for(int child :  e[mid_edge])
        if(!vis[child])
            call(child);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>  n;
    for(int i = 0,a ,b, l;i < n - 1;i++)
    {
        cin >> a >> b >> l;

        e[a].push_back(b);
        e[b].push_back(a);

        ls[a].push_back(l);
        ls[b].push_back(l);
    }

    for(int i = 1;i <= n;i++)
        if(e[i].size() == 1)
        {
            rec(i, 0);
            vis[i] = true;
        }

    for(int i = 1;i <= n;i++)
        if(!vis[i])
        {
            vis[i] = true;
            call(i);
        }
    for(int i = 1;i <= n;i++)
        cout << dist[i] << "\n";

    return 0;
}