#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

bool possible1(int64_t s, int64_t res) {
    res = abs(res);
    return res == s;
}

bool possible2(int64_t *s, int64_t res) {
    res = abs(res);

    int64_t l = s[1];
    int64_t r = s[0];

    if (s[1] * 10 + s[0] == res) return true;
    if (possible1(l, res - r)) return true;
    if (possible1(l, res + r)) return true;
    if (r != 0 && res % r == 0 && possible1(l, res / r)) return true;
    if (possible1(l, res * r)) return true;
    return false;
}

bool possible3(int64_t *s, int64_t res) {
    res = abs(res);

    int64_t *L = s+1;
    int64_t *R = s;

    int64_t l = s[2];
    int64_t r = s[0];

    if (s[2] * 100 + s[1] * 10 + s[0] == res) return true;
    // LEFT GROUP
    if (possible2(L, res - r)) return true;
    if (possible2(L, res + r)) return true;
    if (r != 0 && res % r == 0 && possible2(L, res / r)) return true;
    if (possible2(L, res * r)) return true;
    // RIGHT GROUP
    if (possible2(R, res - l)) return true;
    if (possible2(R, res + l)) return true;
    if (l != 0 && res % l == 0 && possible2(R, res / l)) return true;
    if (res != 0 && l / res == 0 && possible2(R, l / res)) return true;
    return false;
}

int64_t cur_num[6];

int main() {
    int64_t n, k;
    scanf("%lld%lld", &n, &k);

    int64_t ans = 0;

    for (int64_t i = 1; i <= n; ++i) {
        cur_num[0] = (i /   1) % 10;
        cur_num[1] = (i /  10) % 10;
        cur_num[2] = (i / 100) % 10;

        bool pos;
        if      (cur_num[2]) pos = possible3(cur_num, k);
        else if (cur_num[1]) pos = possible2(cur_num, k);
        else                 pos = possible1(cur_num[0], k);
        if (pos) {
            // printf("possible at %d\n", i);
            ans += pos;
        }
    }

    printf("%d\n", ans);
}
