#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 100005
int br;
vector<pair<int, int> > tree[MAXN];
vector<pair<int, int> > down[MAXN];
vector<pair<int, int> > nuevo[MAXN];
vector<int> edg[MAXN];
int sumdown[MAXN], num[MAXN], idxsum[MAXN];
void dfs1(int v, int par){
    int vex = 0;
    for(pair<int, int> p : tree[v]){
        auto [att, w] = p;
        if(att == par) continue;
        dfs1(att, v);
        vex += num[att];
        int cur = sumdown[att] + num[att] * w;
        down[v].push_back({att, cur}); edg[v].push_back(w);
        sumdown[v] += cur;
    }
    vex++; num[v] = vex;
}
void dfs2(int v, int par, int coming, int sum){
    if(v != 1){
        int lef = br - num[v];
        int cur = sum + lef * coming;
        down[v].push_back({-1, cur});
        sumdown[v] += cur;
    }
    int cnt = 0;
    for(pair<int, int> p : down[v]){
        auto [att, val] = p;
        if(att == -1) continue;
        dfs2(att, v, edg[v][cnt], sumdown[v] - val);
        ++cnt;
    }
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    for(int i = 0; i < br - 1; ++i){
        int from, to, w; cin >> from >> to >> w;
        tree[from].push_back({to, w});
        tree[to].push_back({from, w});
    }
    dfs1(1, -1);
    dfs2(1, -1, -1, -1);
    for(int i = 1; i <= br; ++i){
        for(pair<int, int> p : down[i]){
            auto [att, val] = p;
            if(att == -1) nuevo[i].push_back({val, br - num[i]});
            else nuevo[i].push_back({val, num[att]});
        }
    }
    for(int i = 1; i <= br; ++i){
        int cur = 0;
        for(pair<int, int> p : nuevo[i]){
            auto [val, idx] = p;
            cur += (br - 1 - idx) * val;
            cur += val;
        }
        cout << cur << endl;
    }
    return 0;
}