#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MAX_N = 1e4;
const int INF = 1e9;

int len[MAX_N][MAX_N];

std::vector<int> v[MAX_N];

ll ans[MAX_N];

int dep[MAX_N];

int par[MAX_N];

void dfs( int curr ){
	for( int j : v[curr] ){
		if(dep[j] == -1){
			dep[j] = dep[curr] + 1;
			par[j] = curr;
			dfs(j);
		}
	}
}

std::vector<int> p;

void path( int a, int b ){
//	std::cerr<<a<<" "<<b<<":\n";
//	std::cerr<<"dep - "<<dep[a]<<" "<<dep[b]<<":\n\n";

	int sum = 0;
	p.clear();

	p.push_back( a );
	p.push_back( b );
	while( a != b ){
//		std::cerr<<a<<" "<<b<<"\n";
//		std::cerr<<" dep - "<<dep[a]<<" "<<dep[b]<<"\n";

		if( dep[a] < dep[b] ){
			sum += len[b][par[b]];
			b = par[b];
			p.push_back(b);
	//		std::cerr<<"#"<<b<<"\n";
		}else{
			if( dep[a] > dep[b] ){
				sum += len[a][par[a]];
				a = par[a];
				p.push_back(a);
				//std::cerr<<"#"<<a<<"\n";
			}else{
				sum += len[a][par[a]];
				sum += len[b][par[b]];
				a = par[a];
				p.push_back(a);
				b = par[b];
				p.push_back(b);

			}
		}
	}

	for( int j = 0 ;  j < p.size()-1;  j++ ){
		//		std::cerr<<p[j]<<" - ";
		ans[p[j]] += sum;
	}
	//	std::cerr<<" sum :"<<sum<<"\n";

	//	std::cerr<<"\n\n";
}

int main () {

	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

	int n;
	std::cin>>n;

	for( int i=0 ; i<n-1 ; i++ ){
		int a, b, l;
		std::cin>>a>>b>>l;
		a--; b--;
		len[a][b] = l;
		len[b][a] = l;
		v[a].push_back(b);
		v[b].push_back(a);
	}

	for( int i=0 ; i<n ; i++ ) dep[i] = -1;
	dep[0] = 0;
	dfs(0);

	//	for( int i=0 ; i<n ; i++ ) std::cout<<dep[i]<<" ";
	//	std::cout<<"\n";

	for( int i=0 ; i<n ; i++ ){
		for( int j = i+1 ; j<n ; j++ ){
			path( i, j );
		}
	}

	for( int i=0 ; i<n ; i++ ) std::cout<<ans[i]<<"\n";

	return 0;
}