#include <iostream>
#include <vector>
#define int long long
using namespace std;
const int maxn = 1e5+10;

int a[maxn], n;
vector < pair < int, int > > v[maxn];

int find_sum(int x, int end, int p, int sum) {

    if (x == end) {
        
        a[x] += sum;
        return sum;

    }

    int res = -1;
    for (auto [y, d] : v[x]) {

        if (y == p) continue;
        int curr = find_sum(y, end, x, sum+d);
        if (curr == -1) continue;
        a[x] += curr;
        res = curr;
        break;

    }

    return res;

}

void solve() {

    for (int i = 1 ; i <= n ; ++i)
        for (int j = i+1 ; j <= n ; ++j)
            find_sum(i, j, 0, 0);

    for (int i = 1 ; i <= n ; ++i)
        cout << a[i] << '\n';

}

void read() {

    int x, y, d;
    cin >> n;

    for (int i = 2 ; i <= n ; ++i) {

        cin >> x >> y >> d;
        v[x].push_back({y, d});
        v[y].push_back({x, d});

    }

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

signed main () {

    fast_io();
    read();
    solve();

    return 0;

}