#include <iostream>
#include <algorithm>
#include <vector>
#define int long long
using namespace std;
const int maxn = 1e5+10;

int a, b, k;

vector < int > mult(const vector < int > &a, const vector < int > &b) {

    vector < int > ans(k, 0);
    int prenos;
    for (int i = 0 ; i < min((int)a.size(), k) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; (j < b.size() || prenos) && i+j < k ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / 10;
            ans[i+j] %= 10;

        }

    }

    return ans;

}

vector < int > ans, curr;
void solve() {

    cin >> a >> b >> k;
    
    ans.clear();
    ans.push_back(1);
    curr.clear();

    while (a > 0) {

        curr.push_back(a%10);
        a /= 10;

    }


    for (int i = 0 ; (1ll << i) <= b ; ++i) {

        if ((b & (1ll << i)) != 0) ans = mult(ans, curr);
        curr = mult(curr, curr);

    }

    cout << ans[k-1] << '\n';
    

}


void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

int t;
signed main () {

    fast_io();
    cin >> t;

    while (t--) 
        solve();


    return 0;

}
