#include <iostream>
#include <algorithm>
#include <vector>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define int long long
using namespace std;
const int maxn = 1e5+10, base = 1000000000, maxd = 112;

int a, b, k;
vector < int > ans;

inline void mult(vector < int > &a, const vector < int > &b) {

    ans.clear();
    ans.resize(maxd, 0);    
    int prenos;
    for (int i = 0 ; i < min((int)a.size(), maxd) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; (j < b.size() || prenos) && i+j < maxd ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / base;
            ans[i+j] %= base;

        }

    }

    a = ans;

}

inline void mult_10(vector < int > &a, const vector < int > &b) {

    ans.clear();
    ans.resize(k, 0);    
    int prenos;
    for (int i = 0 ; i < min(k, (int)a.size()) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; i+j < k && (j < b.size() || prenos) ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / 10;
            ans[i+j] %= 10;

        }

    }

    a = ans;

}

inline void add_10(vector < int > &a, const vector < int > &b) {

    int prenos = 0;
    ans.resize(k, 0);

    for (int i = 0 ; i < k && i < max(a.size(), b.size()) ; ++i) {

        if (i < a.size()) prenos += a[i];
        if (i < b.size()) prenos += b[i];
        ans[i] = prenos % 10;
        prenos /= 10;

    }

    a = ans;

}

vector < int > to_add;
inline void convert_10(int num) {

    to_add.clear();
    while (num > 0 && to_add.size() < k) {

        to_add.push_back(num % 10);
        num /= 10;

    }

}

void print_num(vector < int > v) {

    for (int i = v.size()-1 ; i >= 0 ; --i)
        cout << v[i];
    cout << '\n';

}

inline void from_binary(const vector < int > v) {

    vector < int > res(v.size(), 0);
    vector < int > power;
    convert_10(base);
    power = to_add;

    for (int i = v.size()-1 ; i >= 0 ; --i) {

        mult_10(res, power);
        convert_10(v[i]);
        add_10(res, to_add);

    }

    cout << res[k-1] << '\n';

}

vector < int > ans1, curr;
inline void solve() {

    cin >> a >> b >> k;
    
    ans1.clear();
    ans1.push_back(1);
    curr.clear();

    while (a > 0) {

        curr.push_back(a % base);
        a /= base;

    }


    for (int i = 0 ; (1ll << i) <= b ; ++i) {

        if ((b & (1ll << i)) != 0) mult(ans1, curr);
        mult(curr, curr);

    }

    from_binary(ans1);

}

inline void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

int t;
signed main () {

    fast_io();
    cin >> t;

    while (t--) 
        solve();


    return 0;

}
