#include <iostream>
#include <unordered_map>
using namespace std;
const int inf = 1e9;

__int128 power[6];
__int128 getkey(__int128 b1, __int128 b2, __int128 b3, __int128 b4, __int128 b5, __int128 last) {

    return b1 * power[6-1] + b2 * power[6-2] + b3 * power[6-3] + b4 * power[6-4] + b5 * power[6-5] + last;

}

unordered_map < __int128, int > m;

int f(int b1, int b2, int b3, int b4, int b5, int last) {

    if (b1+b2+b3+b4+b5 == 0) return 0;
    if (m.count(getkey(b1, b2, b3, b4, b5, last))) return m[getkey(b1, b2, b3, b4, b5, last)];

    int res = inf;
    if (b1 >= 1) res = min(res, f(b1-1, b2, b3, b4, b5, 1) + max(0, last + 1 - 5) );
    if (b2 >= 1) res = min(res, f(b1, b2-1, b3, b4, b5, 2) + max(0, last + 2 - 5) );
    if (b3 >= 1) res = min(res, f(b1, b2, b3-1, b4, b5, 3) + max(0, last + 3 - 5) );
    if (b4 >= 1) res = min(res, f(b1, b2, b3, b4-1, b5, 4) + max(0, last + 4 - 5) );
    if (b5 >= 1) res = min(res, f(b1, b2, b3, b4, b5-1, 5) + max(0, last + 5 - 5) );

    return m[getkey(b1, b2, b3, b4, b5, last)] = res;


}

int b[5];
int main () {

    power[0] = 1;
    for (int i = 1 ; i <= 5 ; ++i)
        power[i] = power[i-1] * (1e4+10);

    cin >> b[0] >> b[1] >> b[2] >> b[3] >> b[4];
    cout << f(b[0], b[1], b[2], b[3], b[4], 0) << '\n';
    return 0;

}