#include <bits/stdc++.h>
using namespace std;
string strip_zero(string s) {
    while(s[0] == '0') {
        s.erase(s.begin(), s.begin() + 1);
    }
    return s;
}
string add(string a, string b, int k) {
    string result = "";
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    int sz;
    if(a.size() > b.size()) {
        sz = a.size();
        int add = sz - b.size();
        for(int i = 0; i < add; i++) {
            b += "0";
        }
    } else {
        sz = b.size();
        int add = sz - a.size();
        for(int i = 0; i < add; i++) {
            a += "0";
        }

    }
    int carry = 0;
    for(int i = 0; i < sz && i < k; i++) {
        int curr = (a[i] - '0') + (b[i] - '0') + carry;
        result += '0' + curr % 10;
        carry = curr / 10;
    }
    result += carry + '0';
    reverse(result.begin(), result.end());
    return strip_zero(result);

}

string multiply(string a, string b, int k) {
    string result = "";
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    if(b.size() > a.size()) {
        swap(a, b);
    }
    int sz = b.size();
    int sz1 = a.size();
    for(int i = 0; i < sz; i++) {
        string curr = "";
        int n = b[i] - '0';
        int carry = 0;
        for(int j = 0; j < sz1 && i < k; j++) {
            int calc = (a[j] - '0') * n + carry;
            curr += calc % 10 + '0';
            carry = calc / 10;
        }
        curr += carry + '0';
        reverse(curr.begin(), curr.end());
        for(int j = 0; j < i; j++) {
            curr += '0';
        }
        result = add(result, strip_zero(curr), k);
    }
    return result;
}
string power(string a, long long b, int k) {
    string result = "1";
    string curr = a;
    while(b > 0) {
        if(b % 2 == 1) {
            result = multiply(result, curr, k);
        }
        curr = multiply(curr, curr, k);
        b /= 2;
    }
    return result;
}
int main() {
    long long t;
    cin >> t;
    for(int p = 0; p < t; p++) {
        long long b, k;
        string a;
        cin >> a >> b >> k;
        string res = power(a, b, k);
        cout << res[res.size() - k] << endl;
    }

    return 0;
}
