#include <bits/stdc++.h>
#include <cinttypes>
#define endl '\n'

long long a, b, d;
int tests, k;
std::vector<char> num, mult;

// long long fast_pow(long long a, long long b, long long d) {
// if (b == 1) {
// return a % d;
// }
// if (b % 2 == 1) {
// return (a * (fast_pow(a, b / 2, d) * fast_pow(a, b / 2, d)) % d) % d;
// }
// return (fast_pow(a, b / 2, d) * fast_pow(a, b / 2, d)) % d;
// }

std::vector<char> sum(std::vector<char> const *a, std::vector<char> const *b) {
  std::vector<char> result;
  int overflow = 0;
  for (size_t i = 0; i < std::min(a->size(), b->size()); ++i) {
    overflow += int((*a)[i]) + int((*b)[i]);
    result.push_back(overflow % 10);
    overflow /= 10;
  }
  for (size_t i = std::min(a->size(), b->size());
       i < std::max(a->size(), b->size()); ++i) {
    if (a->size() > b->size()) {
      result.push_back((*a)[i]);
    } else {
      result.push_back((*b)[i]);
    }
  }
  return result;
}

std::vector<char> multiply1(std::vector<char> const *n, int a) {
  std::vector<char> result;
  int overflow = 0;
  for (size_t i = 0; i < n->size(); ++i) {
    overflow += int((*n)[i]) * a;
    result.push_back(overflow % 10);
    overflow /= 10;
  }
  return result;
}

std::vector<char> multiply(std::vector<char> const *num,
                           std::vector<char> const *mult) {
  std::vector<char> result;
  std::vector<char> overflow = {0};
  for (char i : *mult) {
    std::vector<char> res = multiply1(num, int(i));
    overflow = sum(&overflow, &res);
    result.push_back(overflow[0]);
    std::reverse(overflow.begin(), overflow.end());
    overflow.pop_back();
    std::reverse(overflow.begin(), overflow.end());
  }
  return result;
}

int main() {
  std::cin >> tests;
  for (int t = 0; t < tests; ++t) {
    std::cin >> a >> b >> k;
    for (int i = 0; i < k; ++i) {
      num.push_back(a % 10);
      mult.push_back(a % 10);
      a /= 10;
    }
    for (int i = 0; i < b - 1; ++i) {
      num = multiply(&num, &mult);
    }
    std::cout << int(num[num.size() - 1]) << endl;
  }
  return 0;
}
