#include <bits/stdc++.h>
#define endl '\n'

long long a, b, d;
int tests, k;
std::vector<char> num;

std::vector<char> sum(std::vector<char> const *a, std::vector<char> const *b) {
  std::vector<char> result;
  result.reserve(k);
  int overflow = 0;
  for (size_t i = 0; i < std::min(a->size(), b->size()); ++i) {
    overflow += int((*a)[i]) + int((*b)[i]);
    result.push_back(overflow % 10);
    overflow /= 10;
  }
  for (size_t i = std::min(a->size(), b->size());
       i < std::max(a->size(), b->size()); ++i) {
    if (a->size() > b->size()) {
      result.push_back((*a)[i]);
    } else {
      result.push_back((*b)[i]);
    }
  }
  return result;
}

std::vector<char> multiply1(std::vector<char> const *n, int a) {
  std::vector<char> result;
  result.reserve(k);
  int overflow = 0;
  for (size_t i = 0; i < n->size(); ++i) {
    overflow += int((*n)[i]) * a;
    result.push_back(overflow % 10);
    overflow /= 10;
  }
  return result;
}

std::vector<char> multiply(std::vector<char> const *num,
                           std::vector<char> const *mult) {
  std::vector<char> result;
  result.reserve(k);
  std::vector<char> overflow = {0};
  for (char i : *mult) {
    std::vector<char> res = multiply1(num, int(i));
    overflow = sum(&overflow, &res);
    result.push_back(overflow[0]);
    for (size_t j = 0; j < overflow.size() - 1; ++j) {
      std::swap(overflow[j], overflow[j + 1]);
    }
    overflow.pop_back();
  }
  return result;
}

std::vector<char> fast_pow(std::vector<char> const *a, long long b) {
  if (b == 1) {
    return *a;
  }
  std::vector<char> res = fast_pow(a, b / 2);
  std::vector<char> squared = multiply(&res, &res);
  if (b % 2 == 1) {
    return multiply(a, &squared);
  }
  return squared;
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(NULL);
  std::cin >> tests;
  for (int t = 0; t < tests; ++t) {
    std::cin >> a >> b >> k;
    num.clear();
    num.reserve(k);
    for (int i = 0; i < k; ++i) {
      num.push_back(a % 10);
      a /= 10;
    }
    num = fast_pow(&num, b);
    std::cout << int(num[num.size() - 1]) << endl;
  }
  return 0;
}
