#include <iostream>
#include <vector>
#include <string>
using namespace std;

const int MAX_N = 110;
int ans[110];
int broiSluchai, k;
long long b;
string a;
string currNum;

string umnojenie (string chislo1, string chislo2) {
    int chislo1Size = chislo1.size();
    int chislo2Size = chislo2.size();

    if(chislo1Size == 0 || chislo2Size == 0) {
        return "0";
    }

    vector <int> result(chislo1Size + chislo2Size, 0);

    int index1 = 0;
    int index2 = 0;

    for (int i = chislo1Size - 1; i >= 0; --i) {
        int ostatyk = 0;
        int cifra1 = chislo1[i] - '0';

        index2 = 0;

        for(int j = chislo2Size - 1; j >= 0; --j){
            int cifra2 = chislo2[j] - '0';
            int sum = cifra1 * cifra2 + result[index1 + index2] + ostatyk;

            ostatyk = sum / 10;
            result[index1 + index2] = sum % 10;
            index2 ++;
        }

        if (ostatyk  > 0) {
            result[index1 + index2] += ostatyk;
        }
        index1++;
    }

    int i = result.size() - 1;
    while (i >= 0 && result[i] == 0){
        i--;
    }

    if(i == -1)
        return "0";

    string s = "";

    while(i >= 0){
        s += to_string(result[i--]);
    }
    return s;
}

int main() {

    cin >> broiSluchai;

    for (int i = 0;i < broiSluchai; ++i) {
        cin >> a >> b >> k;
        string proizvedenie = a;
        for (int j = 0;j < b - 1; ++j){
            proizvedenie = umnojenie(proizvedenie, a);
        }
        ans[i] = proizvedenie[proizvedenie.size() - k] - '0';
    }

    for (int i = 0;i < broiSluchai; ++i) {
        cout << ans[i] << endl;
    }
    return 0;
}
