#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=1e5+6;
vector<pair<ll,ll> >g[MAXN];
ll par[MAXN];
ll parW[MAXN];
ll par_by_st[MAXN];
ll st[MAXN];
ll n;
void dfs_init(int u,int p)
{
    st[u]=1;
    for(auto xd:g[u])
    {
        if(xd.first==par[u])continue;
        par[xd.first]=u;
        parW[xd.first]=xd.second;
        dfs_init(xd.first,u);
        st[u]+=st[xd.first];
    }
    par_by_st[u]=parW[u]*st[u];
}
ll dp[MAXN];
ll ans[MAXN];
ll dp1[MAXN];
void dfs_solve1(int u,int p)
{
    for(auto xd:g[u])
    {
        if(xd.first==p)continue;
        dfs_solve1(xd.first,u);
        ans[u]+=xd.second*st[xd.first]*(n-st[xd.first]);
        dp[u]+=xd.second*st[xd.first];
        ans[u]+=dp[xd.first]*(n-st[xd.first]);
        dp[u]+=dp[xd.first];
    }
}
void dfs_solve2(int u,int p)
{
    ll sum=0;
    vector<pair<ll,ll> >ch;
    for(auto xd:g[u])
    {
        if(xd.first==p)continue;
        ch.push_back({xd.first,dp[xd.first]+xd.second*st[xd.first]});
        sum+=ch.back().second;
    }
    for(auto xd:ch)
    {
        dp1[xd.first]=dp1[u]+sum-xd.second+parW[xd.first]*(n-st[xd.first]);
        ans[xd.first]+=dp1[xd.first]*st[xd.first];
    }
    for(auto xd:ch)dfs_solve2(xd.first,u);
}
ll ans1[MAXN];
bool vis[MAXN];
vector<pair<vector<int>,ll> >paths;
vector<int>cur_p;
int cur_sum=0;
void dfs_paths(int u,int p)
{
    cur_p.push_back(u);
    paths.push_back({cur_p,cur_sum});
    for(auto xd:g[u])
    {
        if(xd.first==p)continue;
        cur_sum+=xd.second;
        dfs_paths(xd.first,u);
        cur_sum-=xd.second;
    }
    cur_p.pop_back();
}
void solve_dumb()
{
    for(int i=1;i<=n;i++)
    {
        dfs_paths(i,0);
    }
    for(auto xd:paths)
    {
        for(auto dx:xd.first)
        {
            ans1[dx]+=xd.second;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i=1;i<n;++i)
    {
        int x,y,l;
        cin>>x>>y>>l;
        //l=rand()%10+1;
        g[x].push_back({y,l});
        g[y].push_back({x,l});
    }
    dfs_init(1,0);
    dfs_solve1(1,0);
    /*for(int i=1;i<=n;i++)
    {
        cout<<ans[i]<<endl;
    }*/
    dfs_solve2(1,0);
    //solve_dumb();
    for(int i=1;i<=n;++i)
    {
        cout<<ans[i];
        //cout<<" "<<ans1[i]/2;
        cout<<'\n';
    }
return 0;
}
/*
6
1 2 1
2 3 1
3 4 1
4 5 1
4 6 1
*/
