#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct edge
{
    long long vr, d;
    edge() {}
    edge(long long a, long long b)
    {
        vr=a;
        d=b;
    }
};

long long n;
vector<edge> gr[100005];
long long brt[100005];
long long sm[100005];
long long par[100005];

void dfs(long long v)
{
    brt[v]=1;
    long long brs=gr[v].size();
    for(long long i=0; i<brs; i++)
    {
        long long nv=gr[v][i].vr, nl=gr[v][i].d;
        if(par[v]==nv) continue;
        par[nv]=v;
        dfs(nv);
        brt[v]+=brt[nv];
        sm[v]+=sm[nv]+brt[nv]*nl;
    }
}

long long sm2[100005];

void dfs2()
{
    for(long long v=1; v<=n; v++)
    {
        long long brs=gr[v].size();
        for(long long i=0; i<brs; i++)
        {
            long long nv=gr[v][i].vr, nl=gr[v][i].d;
            if(par[v]==nv) continue;
            sm2[v]+=(sm[nv]+brt[nv]*nl)*(brt[v]-brt[nv]);
        }
    }
}


long long sm3[100005];

void dfs3(long long v, long long st)
{
    sm3[v]+=sm2[v];
    long long brs=gr[v].size();
    for(long long i=0; i<brs; i++) if(gr[v][i].vr!=par[v]) st+=sm[gr[v][i].vr]+brt[gr[v][i].vr]*gr[v][i].d;

    for(long long i=0; i<brs; i++)
    {
        long long nv=gr[v][i].vr, nl=gr[v][i].d;
        if(par[v]==nv) continue;
        long long nst=st;
       /// cout<<v<<" "<<nv<<" "<<nst<<endl;
        nst-=(sm[nv]+brt[nv]*nl);
        nst+=(n-brt[nv])*nl;
       /// cout<<v<<" "<<nv<<" "<<nst<<endl;
        sm3[nv]+=nst*brt[nv];
        sm3[nv]+=sm[nv]*(brt[v]-brt[nv]);
        dfs3(nv, nst);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(long long i=0; i<n-1; i++)
    {
        long long v1, v2, t;
        cin>>v1>>v2>>t;
        gr[v1].push_back(edge(v2, t));
        gr[v2].push_back(edge(v1, t));
    }
    par[1]=1;
    dfs(1);
    dfs2();
    dfs3(1, 0);
    for(long long i=1; i<=n; i++) cout<<sm3[i]<<endl;
    return 0;
}
