#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5 + 5;

unsigned long long sums[MAXN];

int n;
vector <pair<int, int> > G[MAXN];

bool used[MAXN];

int from, to;
bool found = 0;

int temporary = 0;

vector <int> c;

void dfs(int s, int sum = 0)
{
    if (found) return;
    for (int i = 0; i < G[s].size(); i++)
    {
        int v = G[s][i].first;
        int tg = G[s][i].second;

        if (used[v]) continue;
        used[v] = 1;

        if (!found) c.push_back(v);

        if (v == to && !found)
        {
            temporary = sum + tg;
            found = 1;
            break;
        }

        dfs(v, sum + tg);

        if (!found) c.pop_back();
    }
}


int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i < n; i++)
    {
        int x, y, l;
        cin >> x >> y >> l;

        G[x].push_back({y, l});
        G[y].push_back({x, l});
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = i+1; j <= n; j++)
        {
            memset(used, 0, sizeof(used));
            c.clear();
            c.push_back(i);
            temporary = 0;
            from = i;
            to = j;

            found = 0;
            used[from] = 1;

            dfs(from);

            if (temporary < 0) return 1;

//            cerr << from << " " << to << endl;

            for (int k = 0; k < c.size(); k++)
            {
                sums[c[k]] += temporary;
//                cerr << c[k] << " ";
            }
//            cerr << endl << endl;;


        }
    }

    for (int i = 1; i <= n; i++)
    {
        cout << sums[i] << endl;
    }

    return 0;
}
/**
6
1 2 3
1 4 5
3 4 7
4 5 9
4 6 10

---
107
61
67
182
75
79

*/



