#include <bits/stdc++.h>
#define endl '\n'
#define LL unsigned long long int
using namespace std;

int brc = 0;

string mult(string a, string b)
{
    if (a.size() > brc) a = a.substr(a.size() - brc, brc);
    if (b.size() > brc) b = b.substr(b.size() - brc, brc);

    int add1 = b.size()-a.size();
    int add2 = a.size()-b.size();

    for (int i = 0; i < add1; i++) a = "0" + a;
    for (int i = 0; i < add2; i++) b = "0" + b;

    string res(a.size() * 2, '0');

    int br = 0;

    for (int i = a.size() - 1; i >= 0; i--)
    {
        LL ost = 0;

        for (int j = b.size() - 1; j >= 0; j--)
        {
            int tmp = (a[i] - '0') * (b[j] - '0') + res[i+j+1] - '0' + ost;

            res[i+j+1] = (char)(tmp%10 + '0');

            ost = tmp/10;
        }
        if (ost) res[i] = (char)(ost + '0');

        br++;
        if (br > brc) return res;
    }

    if (res.size() > brc) res = res.substr(res.size() - brc, brc);

    return res;
}

string fast_pow(string base, LL pw)
{
    if (pw <= 1) return base;
    string c = fast_pow(base, pw/2);
    if (pw%2 == 0) return mult(c, c);

//    cerr << c << " " << mult(c, c) << " " << mult(mult(c, c), base) << endl;

    return mult(mult(c, c), base);
}

void solve()
{
    string a;
    LL b;
    int k;
    cin >> a >> b >> k;

    brc = k;

    string p = fast_pow(a, b);

    int sz = p.size();
    cout << p[sz-k] << endl;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
/**
1
42 7 7

9

1
123123123123132 1231321231231313 100


*/
