#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

long long k;
vector<long long> v[MAXN + 5];

bool solve(int n)
{
    v[n].push_back(n);
    v[n].push_back(-n);
    for (int i = 10; i <= n; i *= 10)
    {
        vector<long long> t = v[n % i];
        if (n % i < i / 10) t.push_back(0);
        for (auto v1 : v[n / i])
        {
            for (auto v2 : t)
            {
                v[n].push_back(v1 + v2);
                v[n].push_back(v1 - v2);
                v[n].push_back(-v1 + v2);
                v[n].push_back(-v1 - v2);
                v[n].push_back(v1 * v2);
                v[n].push_back(-v1 * v2);
                if (v2 != 0 and v1 % v2 == 0)
                {
                    v[n].push_back(v1 / v2);
                    v[n].push_back(-v1 / v2);
                }
            }
        }
    }

    sort(v[n].begin(), v[n].end());
    auto it = unique(v[n].begin(), v[n].end());
    v[n].resize(distance(v[n].begin(), it));

    int p = lower_bound(v[n].begin(), v[n].end(), k) - v[n].begin();
    if (p >= v[n].size() or v[n][p] != k) return false;
    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n >> k;

    int cnt = 0;
    for (int i = 0; i <= n; ++ i)
    {
        if (solve(i)) cnt++;
    }

    cout << cnt << endl;

    return 0;
}
