#include <iostream>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

long long k;
vector<long long> v[MAXN + 5];

bool solve(int n)
{
    set<long long> s;
    s.insert(n);
    s.insert(-n);
    for (int i = 10; i <= n; i *= 10)
    {
        for (auto v1 : v[n / i])
        {
            if (n % i < i / 10)
            {
                s.insert(v1);
                s.insert(-v1);
                s.insert(0);
            }
            for (auto v2 : v[n % i])
            {
                s.insert(v1 + v2);
                s.insert(v1 - v2);
                s.insert(-v1 + v2);
                s.insert(-v1 - v2);
                s.insert(v1 * v2);
                s.insert(-v1 * v2);
                if (v2 != 0 and v1 % v2 == 0)
                {
                    s.insert(v1 / v2);
                    s.insert(-v1 / v2);
                }
            }
        }
    }

    bool flag = false;
    for (auto it = s.begin(); it != s.end(); ++ it)
    {
        v[n].push_back(*it);
        if ((*it) == k) flag = true;
    }
    return flag;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n >> k;

    int cnt = 0;
    for (int i = 0; i <= n; ++ i)
    {
        if (solve(i)) cnt++;
    }

    cout << cnt << endl;

    return 0;
}
