#include <iostream>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

long long k;
int used[2 * MAXN + 5];
vector<long long> v[MAXN + 5];

void add(int n, long long a)
{
    if (used[MAXN + a] == n) return;
    v[n].push_back(a);
    used[MAXN + a] = n;
}

bool solve(int n)
{
    add(n, n);
    add(n, -n);
    for (int i = 10; i <= n; i *= 10)
    {
        for (auto v1 : v[n / i])
        {
            if (n % i < i / 10)
            {
                add(n, v1);
                add(n, -v1);
                add(n, 0);
            }
            for (auto v2 : v[n % i])
            {
                add(n, v1 + v2);
                add(n, v1 - v2);
                add(n, -v1 + v2);
                add(n, -v1 - v2);
                add(n, v1 * v2);
                add(n, -v1 * v2);
                if (v2 != 0 and v1 % v2 == 0)
                {
                    add(n, v1 / v2);
                    add(n, -v1 / v2);
                }
            }
        }
    }

    return (used[MAXN + k] == n);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n >> k;

    for (int i = 0; i <= 2 * MAXN; ++ i)
    {
        used[i] = -1;
    }

    int cnt = 0;
    for (int i = 0; i <= n; ++ i)
    {
        if (solve(i)) cnt++;
    }

    cout << cnt << endl;

    return 0;
}
