#include <bits/stdc++.h>
using namespace std;

string addition (string a, string b) {
    if (b.size() > a.size()) {swap (a, b);}
    reverse (a.begin(), a.end());
    reverse (b.begin(), b.end());
    string ans = "";
    int carry = 0;
    for (int i=0; i < b.size(); i++) {
        int k = (a[i] - '0') + (b[i] - '0') + carry;
        if (k >= 10) {k -= 10; carry = 1;}
        else {carry = 0;}
        ans = ans + char(k + '0');
    }

    for (int i=b.size(); i < a.size(); i++) {
        int k = (a[i] - '0') + carry;
        if (k >= 10) {k -= 10; carry = 1;}
        else {carry = 0;}
        ans = ans + char(k + '0');
    }
    if (carry > 0) {ans += char (carry + '0');}
    reverse (ans.begin(), ans.end());
    return ans;
}

string s (long long a) {
    string ans="";
    while (a > 0) {
        ans = ans + char(a%10 + '0');
        a /= 10;
    }
    reverse (ans.begin(), ans.end());
    return ans;
}

string multiply (string a, long long b) {
    string ans = "";
    string b1 = s(b/2);
    reverse (b1.begin(), b1.end());
    for (int i=0; i < b1.size(); i++) {
        int k = b1[i] - '0';
        string p = "0";
        for (int j=1; j <= k; j++) {p = addition (p, a);}
        for (int j=1; j <= i; j++) {p = p + "0";}
        ans = addition (ans, p);
    }
    ans = addition(ans, ans);
    if (b%2 == 1) {ans = addition (ans, a);}
    return ans;
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

//cout << multiply ("15", 1000) << endl;

int t;
cin >> t;

for (int o=0; o < t; o++) {
    long long a, b, k;
    cin >> a >> b >> k;
    string ans="1";
    for (int i=1; i < b; i++) {
        ans = multiply (ans, a);
    }
    //cout << ans << endl;
    cout << ans[ans.size() - k] << endl;
}

return 0;
}