#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e5+10;
vector <pair <int,long long> > v[MAXN];
long long wd[MAXN], wu[MAXN], sd[MAXN], su[MAXN], ans[MAXN];
pair <int, long long> p[MAXN];
bool used[MAXN];
void dfs_down(int x) {
    used[x]=true;
    wd[x]=sd[x]=0;
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        p[i.first]={x,i.second};
        dfs_down(i.first);
        wd[x]+=wd[i.first]+1;
        sd[x]+=sd[i.first]+i.second*(wd[i.first]+1);
    }
    cout << wd[x] << ' ' << sd[x] << ' ' << x << endl;
}
void dfs_up(int x) {
    used[x]=true;
    wu[x]=su[x]=0;
    if (p[x].first!=-1) {
        int ind=p[x].first;
        for (auto i:v[ind]) {
            if (i.first!=p[ind].first && i.first!=x) {
                wu[x]+=wd[i.first]+1;
                su[x]+=sd[i.first]+i.second*(wd[i.first]+1);
            }
        }
        wu[x]+=wu[ind]+1;
        su[x]+=su[ind];
        su[x]+=wu[x]*p[x].second;
    }
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        dfs_up(i.first);
    }
}
void dfs_ans(int x) {
    used[x]=true;
    long long sum, ways, cur;
    sum=su[x]+sd[x];
    ways=wu[x]+wd[x];
    ans[x]=0;
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        cur=sd[i.first]+i.second*(wd[i.first]+1);
        ans[x]+=cur*(ways-wd[i.first]-1)+(sum-cur)*(wd[i.first]+1);
        ans[x]+=2*cur;
    }
    if (p[x].first!=-1) {
        ans[x]+=su[x]*wd[x]+(sum-su[x])*wu[x];
        ans[x]+=2*su[x];
    }
    ans[x]/=2;
    for (auto i:v[x]) {
        if (used[i.first]) continue;
        dfs_ans(i.first);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x, y;
    long long l;
    cin >> n;
    for (int i=0;i<n-1;i++) {
        cin >> x >> y >> l;
        v[x].push_back({y,l});
        v[y].push_back({x,l});
    }
    p[1]={-1,0};
    dfs_down(1);
    for (int i=1;i<=n;i++) used[i]=false;
    dfs_up(1);
    for (int i=1;i<=n;i++) used[i]=false;
    dfs_ans(1);
    for (int i=1;i<=n;i++) cout << ans[i] << endl;
    return 0;
}
