#include <iostream>
#include <vector>
#include <algorithm>

const int maxn = 1e5;

std::vector <std::pair <int, int> > v[maxn];
int ans[maxn];
int vis[maxn][maxn];

void dfs(int f, std::pair <int, int> curr, int prev)
{
    if (vis[f][curr.first] != -1) return ;
    vis[f][curr.first] = vis[f][prev] + curr.second;
    for (auto i: v[curr.first])
    {
        dfs(f, i, curr.first);
    }
}

int main()
{
    int n;
    std::cin>>n;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b, c;
        std::cin>>a>>b>>c;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }
    for (int i = 1; i <= n; ++i)
    {
        dfs(i, {i, 0}, 0);
        for (int j = 0; j < n; ++j)
        {
            vis[i][j] = -1;
        }
    }
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j) 
        {
            std::cout<<i<<':'<<j<<' '<<vis[i][j]<<'\n';
        }
    }

    return 0;
}
