#include <iostream>
#include <vector>
#include <algorithm>

const int maxn = 2 * 1e3;

std::vector <std::pair <int, int> > v[maxn];
int ans[maxn];
int vis[maxn][maxn];
std::pair <int, int> brrebra[maxn];

void dfs(int f, std::pair <int, int> curr, int prev)
{
    if (vis[f][curr.first] != -1) return ;
    vis[f][curr.first] = vis[f][prev] + curr.second;
    for (auto i: v[curr.first])
    {
        dfs(f, i, curr.first);
    }
}

int main()
{
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    int n;
    std::cin>>n;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b, c;
        std::cin>>a>>b>>c;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
        brrebra[a].first++;
        brrebra[a].second = a;
        brrebra[b].first++;
        brrebra[b].second = b;
    }
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            vis[i][j] = -1;
        }
        dfs(i, {i, 0}, 0);
    }
    std::sort(brrebra + 1, brrebra + n + 1);
    for (int i = 1; i <= n; ++i)
    {
        int vruh = brrebra[i].second;
        for (int j = 1; j <= n; ++j)
        {
            ans[vruh] += vis[vruh][j];
        }
    }
    for (int i = 1; i <= n; ++i)
    {
        std::cout<<ans[i]<<'\n';
    }




    return 0;
}
