#include <bits/stdc++.h>
using namespace std;
int n,x,y,l;
int const maxn = 10000;
int used[maxn];
const int INF = 1000000000;
vector<vector<pair<int,int>>> adj;

void dijkstra(int s, vector<int>&d)
{
    int n=adj.size();
    d.assign(n,INF);
    d[s]=0;
    using pii = pair<int,int>;
    priority_queue<pii,vector<pii>,greater<pii>>q;
    q.push({0,s});
    while(!q.empty())
    {
        int v = q.top().second;
        int d_v = q.top().first;
        q.pop();
        if(d_v!=d[v])
            continue;
        for(auto edge : adj[v])
        {
            int to = edge.first;
            int len = edge.second;
            if(d[v]+len<d[to])
            {
                d[to] = d[v]+len;
                q.push({d[to],to});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    int dp[n][n];
    for(int i=1; i<n; i++)
    {
        cin>>x>>y>>l;
        adj[x].push_back[{y,l}];
        adj[y].push_back[{y,l}];
        
        
    }
    for(int i = 1;i<=n;i++)
    {
        vector<int> d;
        dijkstra(i,d);
        for(int j=1;j<=d.size(),j++)
        {
            dp[i][j]= d[j];
        }
    }
    
    for(int i=1;i<=n;i++)
    {
        sum=0
        for(int j =1;j<=n;j++)
        {
            if(i==j)
                sum+=0
            else
                sum+=dp[i][j]
        }
        cout<<sum;
    }


}
