#include <stdio.h>
#include <stdlib.h>

#define ll long long

ll pow(ll num, ll exp){
	ll result = 1;
	for(ll i = 0; i < exp; i++) result *= num;
	return result;
}

int solve(ll a, ll b, ll k){
	int mask = pow(10, k);
	ll result = 1;
	for(int i = 0; i < b; i++){
		result *= a;
		result %= mask;	
	}
	
	return result / (mask / 10);
}

/*
int solve(ll a, ll b, ll k){
	ll temp = pow(10, k);
	return (pow(a, b) % temp) / (temp / 10); 
}
*/

int main(){
	int t;
	scanf("%d", &t);
	ll input[t][3];
	for(int i = 0; i < t; i++){
		scanf("%lld %lld %lld", &input[i][0], &input[i][1], &input[i][2]);
	}
	for(int i = 0; i < t; i++){
		printf("%d\n", solve(input[i][0], input[i][1], input[i][2]));
	}
	return 0;
}
