#include <stdio.h>
#include <stdlib.h>

#define ll long long 

/* 3 1 4 2 1 
 * 1 - 3
 * 2 - 1
 * 3 - 4
 * 4 - 2
 * 5 - 1
 *
 * left:
 * 1: 0 
 * 2: 0
 * 3: 2 
 * 4: 0
 * 5: 1
 * 
 * 2 1 4 2 0 (1) 
 * newest:
 * 2: 1
 * 3: 4
 *
 * 3: 
 * 11100
 * 10011
 * 01110
 * 11001
 * 00111
 * 11001
 * 00111
 *
 * 2:
 * 11000
 * 00110
 * 00011
 * 11000
 * 00110
 * 
 * 4:
 * 11110
 * 01111
 * 11110
*/

void sub(int *n1, int *n2){
	if(*n1 == 0 || *n2 == 0) return;
	if(*n1 > *n2){
		*n1 -= *n2;
		*n2 = 0;
	}else{
		*n2 -= *n1;
		*n1 = 0;
	}
}

int abs(int n){
	if(n < 0) return 0;
	return n;
}

int solve(int input[5]){
	int result = 0;
	for(int i = 0; i < 4; i++){
		if(input[4] > 0){
			if(input[i] < input[4]){
				result += (i+1) * input[i];
				input[4] -= input[i];
				input[i] = 0;
			}else{
				result += (i+1) * input[4];
				input[i] -= input[4];
				input[4] = 0;
				break;
			}
		}else break;
	}
	for(int i = 3; i > 0; i--){
		for(int j = 0; j < 4 - i; j++){
			sub(&input[i], &input[j]);
		}
	}	
	result += input[1] / 3;
	result += abs(input[2] - 1);
	result += abs((input[3] - 1) * 3);
	result += abs((input[4] - 1) * 5);
//	for(int i = 0; i < 5; i++) printf("%d ", input[i]);

	return result;
}

int main(){
	int input[5];
	for(int i = 0; i < 5; i++) scanf("%d", input + i);
	printf("%d", solve(input));
	return 0;
}
