#include <iostream>
#include <string>
using namespace std;
#define int unsigned long long
#define endl '\n'
#define MODULE 1000000000
int mult(int a, int b){
    if(b == 0) return 0;
    if(b % 2 != 0) return (a + mult(a, b - 1)) % MODULE;
    int half = mult(a, b / 2);
    return (half + half) % MODULE;
}
int power(int a, int b){
    if(b == 0) return 1;
    if(b % 2 != 0){
        return mult(a, power(a, b - 1));
    }
    int half = power(a, b / 2);
    return mult(half, half);
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while(t--){
        int a, b, k; cin >> a >> b >> k;
        int res = power(a, b);
        string s = to_string(res);
        //cout << s << endl;
        cout << s[s.size() - k] << endl;
    }
    return 0;
}