#include<iostream>
#include<queue>
#define MAXN 2009
using namespace std;
int n,m;
int dist[MAXN]; /// otgovorut
int s[MAXN][MAXN];
vector<pair<int,int>> a[MAXN];
bool used[MAXN];
void bfs(int vr){
    queue<int> q;
    q.push(vr);
    used[vr]=1;
    while(!q.empty()){
        int curr=q.front();
        q.pop();
        for(auto to:a[curr]){
            int edge=to.first,raz=to.second;
            if(!used[edge]){
                q.push(edge);
                s[vr][edge]=s[vr][curr]+s[curr][edge];
                dist[vr]+=s[vr][edge];
                used[edge]=1;
            }
        }
    }
}
int main(){
    cin>>n;
    m=n-1;
    for(int i=0;i<m;i++){
        int x,y,t;
        cin>>x>>y>>t;
        x--; y--;
        a[x].push_back({y,t});
        a[y].push_back({x,t});
        s[x][y]=t;
        s[y][x]=t;
    }
    for(int i=0;i<n;i++){
        bfs(i);
        for(int j=0;j<n;j++) used[j]=0;
    }
    for(int i=0;i<n;i++){
        for(int j=i+1;j<n;j++){
            for(int k=0;k<n;k++){
                if(k!=i and k!=j){
                    if(s[i][j]==s[i][k]+s[k][j]) dist[k]+=s[i][j];
                }
            }
        }
    }
    for(int i=0;i<n;i++) cout<<dist[i]<<"\n";
    return 0;
}
