#include <iostream>
#include <vector>
#define int long long
using namespace std;
const int maxn = 1e5+10;

int s[maxn], n;
int sum[maxn], ans[maxn];
vector < pair < int, int > > v[maxn];

void find_s(int x, int p) {

    s[x] = 1;
    for (auto [i, d] : v[x]) {

        if (i == p) continue;
        find_s(i, x);
        s[x] += s[i];

    }

}

int find_subtree(int x, int p, int curr) {

    sum[x] = s[x] * curr;

    for (auto [y, d] : v[x]) {

        if (y == p) continue;
        int res = find_subtree(y, x, d);
        ans[x] += res * (n - s[y]);
        sum[x] += res;

    }

    return sum[x];

}

void find_above(int x, int p, int par_add, int incoming) {

    ans[x] += (sum[1] - sum[x] + incoming * s[x] + par_add) * s[x];
    for (auto [y, d] : v[x]) {

        if (y == p) continue;
        find_above(y, x, par_add + (n - 2*s[y]) * d, d);

    }

}

void solve() {

    find_s(1, 0);
    find_subtree(1, 0, 0);
    find_above(1, 0, 0, 0);

    for (int i = 1 ; i <= n ; ++i)
        cout << ans[i] << '\n';


}

void read() {

    int x, y, d;
    cin >> n;

    for (int i = 2 ; i <= n ; ++i) {

        cin >> x >> y >> d;
        v[x].push_back({y, d});
        v[y].push_back({x, d});

    }

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

signed main () {

    fast_io();
    read();
    solve();

    return 0;

}