#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int n, k;

bool check_two(int x, int y) {

    if (x*10 + y == k) return 1;
    if (x + y == k) return 1;
    if (abs(x - y) == k) return 1;
    if (x * y == k) return 1;
    if (y != 0 && x % y == 0 && x / y == k) return 1;
    return 0;

}

int sign[2];

int get_res(int x, int y, int op) {

    if (op == 0) return x+y;
    if (op == 1) return x-y;
    if (op == 2) return (y == 0 ? -1 : x/y);
    return x*y;

}

bool check(int num) {

    if (num < 10) return (num == k);
    if (num < 100) return check_two(num / 10, num % 10);
    if (num == k) return 1;
    if (check_two(num/10, num%10)) return 1;
    if (check_two(num/100, num%100)) return 1;

    int reald1 = num / 100;
    int reald2 = (num % 100) / 10;
    int reald3 = num % 10;

    for (int mask = 0 ; mask < 8 ; ++mask) {

        int d1, d2, d3;
        d1 = reald1;
        d2 = reald2;
        d3 = reald3;

        if (mask & (1 << 0)) d1 = -d1;
        if (mask & (1 << 1)) d2 = -d2;
        if (mask & (1 << 2)) d3 = -d3;

        for (int i = 0 ; i < 16 ; ++i) {

            sign[0] = i / 4;
            sign[1] = i % 4;
            
            bool bl1 = 1, bl2 = 1;
            int res1, res2;
            
            if (sign[0] == 2 && (d2 == 0 || d1 % d2 != 0)) bl1 = 0;
            if (sign[1] == 2 && (d3 == 0 || get_res(d1, d2, sign[0]) % d3 != 0)) bl1 = 0;
            
            if (sign[1] == 2 && (d3 == 0 || d2 % d3 != 0)) bl2 = 0;
            if (sign[0] == 2 && (get_res(d2, d3, sign[1]) == 0 || d1 % get_res(d2, d3, sign[1]) != 0)) bl2 = 0;

            res1 = get_res(d1, d2, sign[0]);
            res1 = get_res(res1, d3, sign[1]);

            res2 = get_res(d2, d3, sign[1]);
            res2 = get_res(d1, res2, sign[0]);

            if ((bl1 && abs(res1) == k) || (bl2 && abs(res2) == k)) {
            
                return 1;
            
            }

        }
    }

    return 0;

}

signed main () {

    cin >> n >> k;
    k = abs(k);

    int ans = (n == 1000 && (k == 0 || k == 1 || k == 10 || k == 1000 || k == 1000));
    for (int i = 1 ; i <= min(n, 999) ; ++i) {
    
        ans += check(i);
        // if (check(i)) cout << i << '\n';

    }

    cout << ans << '\n';

    return 0;

}
