#include <iostream>
#include <algorithm>
#include <vector>
#define int long long
using namespace std;
const int maxn = 1e5+10, maxd = 50;

int a, b, k;
vector < int > mult(const vector < int > &a, const vector < int > &b) {

    vector < int > ans(maxd, 0);
    int prenos;
    for (int i = 0 ; i < min((int)a.size(), maxd) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; (j < b.size() || prenos) && i+j < maxd ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / 2;
            ans[i+j] %= 2;

        }

    }

    return ans;

}

vector < int > mult_10(const vector < int > &a, const vector < int > &b) {

    vector < int > ans(k, 0);
    int prenos;
    for (int i = 0 ; i < min((int)a.size(), k) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; (j < b.size() || prenos) && i+j < k ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / 10;
            ans[i+j] %= 10;

        }

    }

    return ans;

}

void from_binary(const vector < int > &a) {

    vector < int > res(k, 0);
    vector < int > two = {2};

    for (int i = a.size()-1 ; i >= 0 ; --i) {

        res = mult_10(res, two);
        if (a[i] == 0) continue;
        int j = 0;
        while (j < k && res[j] == 9) {
        
            res[j] = 0;
            ++j;
        
        }

        if (j < k) ++res[j];

    }

    cout << res[k-1] << '\n';

}

vector < int > ans, curr;
void solve() {

    cin >> a >> b >> k;
    
    ans.clear();
    ans.push_back(1);
    curr.clear();

    while (a > 0) {

        curr.push_back(a%2);
        a /= 2;

    }


    for (int i = 0 ; (1ll << i) <= b ; ++i) {

        if ((b & (1ll << i)) != 0) ans = mult(ans, curr);
        curr = mult(curr, curr);

    }

   
    from_binary(ans);
    

}


void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

int t;
signed main () {

    fast_io();
    cin >> t;

    while (t--) 
        solve();


    return 0;

}
