#include <iostream>
#include <cassert>
#include <map>
using namespace std;
const int inf = 1e9;

struct key {

    int b[6];
    key(){}
    key(int b1, int b2, int b3, int b4, int b5, int last) {

        b[0] = b1;
        b[1] = b2;
        b[2] = b3;
        b[3] = b4;
        b[4] = b5;
        b[5] = last;

    }
    inline friend bool operator < (key a, key b) {

        for (int i = 0 ; i < 6 ; ++i)
            if (a.b[i] != b.b[i]) return a.b[i] < b.b[i];
        return 0;

    }

};

int b[6];
map < key, int > m;

int f(int b1, int b2, int b3, int b4, int b5, int last) {

    if (b1+b2+b3+b4+b5 == 0) return 0;
    if (m.count({b1, b2, b3, b4, b5, last})) return m[{b1, b2, b3, b4, b5, last}];

    int res = inf;
    if (b1 >= 1) res = min(res, f(b1-1, b2, b3, b4, b5, 1) + max(0, last + 1 - 5) );
    if (b2 >= 1) res = min(res, f(b1, b2-1, b3, b4, b5, 2) + max(0, last + 2 - 5) );
    if (b3 >= 1) res = min(res, f(b1, b2, b3-1, b4, b5, 3) + max(0, last + 3 - 5) );
    if (b4 >= 1) res = min(res, f(b1, b2, b3, b4-1, b5, 4) + max(0, last + 4 - 5) );
    if (b5 >= 1) res = min(res, f(b1, b2, b3, b4, b5-1, 5) + max(0, last + 5 - 5) );

    return m[{b1, b2, b3, b4, b5, last}] = res;


}

void solve_dp() {

    cout << f(b[1], b[2], b[3], b[4], b[5], 0) << '\n';

}

int ans;
int main () {
    
    cin >> b[1] >> b[2] >> b[3] >> b[4] >> b[5];
    if (b[1]+b[2]+b[3]+b[4]+b[5] <= 100) solve_dp();
    else assert(b[1]+b[2]+b[3]+b[4]+b[5] <= 1000);
    return 0;

}