#include <bits/stdc++.h>
using namespace std;
long long del = 1000000000;
string strip_zero(string s) {
    while(s[0] == '0') {
        s.erase(s.begin(), s.begin() + 1);
    }
    return s;
}
string toString(long long n) {
    string s = "";
    while(n > 0) {
        s += '0' + n % 10;
        n /= 10;
    }
    reverse(s.begin(), s.end());
    return s;
}
long long toLL(string s) {
    long long n = 0;
    reverse(s.begin(), s.end());
    long long multiplier = 1;
    for(char c : s) {
        n += (c - '0') * multiplier;
        multiplier *= 10;
    }
    return n;
}
string add(string a, string b) {
    int a_sz = (a.size() % 9 == 0 ? a.size() / 9 : a.size() / 9 + 1);
    int b_sz = (b.size() % 9 == 0 ? b.size() / 9 : b.size() / 9 + 1);
    int la = 9;
    int lb = 9;
    long long a_bit[a_sz];
    long long b_bit[b_sz];
    for(int i = 0; i < a_sz; i++){
        string s1 = "";
        for(int j = a.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += a[j];
            else la--;
        }
        a_bit[i] = toLL(s1);
    }
    for(int i = 0; i < b_sz; i++){
        string s1 = "";
        for(int j = b.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += b[j];
            else lb--;
        }
        b_bit[i] = toLL(s1);
    }
    string result = "";
    int carry = 0;
    if(a_sz > b_sz) {
        for(int i = 0; i < a_sz; i++) {
            long long nd;
            if(i < b_sz)
                nd = a_bit[i] + b_bit[i];
            else
                nd = a_bit[i];
            result = toString(nd % del + carry) + result;
            carry = nd / (i == a_sz - 1 ? pow(10, la) : del);
        }
        result = (char)('0' + carry) + result;
    } else {
        for(int i = 0; i < b_sz; i++) {
            long long nd;
            if(i < a_sz)
                nd = a_bit[i] + b_bit[i];
            else
                nd = b_bit[i];
            result = toString(nd % del + carry) + result;
            carry = nd / (i == b_sz - 1 ? pow(10, max(a_bit[i], b_bit[i])) : del);
        }
        result = (char)('0' + carry) + result;
    }
    return strip_zero(result);
}
string multiply(string a, string b) {
    int a_sz = (a.size() % 9 == 0 ? a.size() / 9 : a.size() / 9 + 1);
    int b_sz = (b.size() % 9 == 0 ? b.size() / 9 : b.size() / 9 + 1);
    int la = 9;
    int lb = 9;
    long long a_bit[a_sz];
    long long b_bit[b_sz];
    for(int i = 0; i < a_sz; i++){
        string s1 = "";
        for(int j = a.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += a[j];
            else la--;
        }
        a_bit[i] = toLL(s1);
    }
    for(int i = 0; i < b_sz; i++){
        string s1 = "";
        for(int j = b.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += b[j];
            else lb--;
        }
        b_bit[i] = toLL(s1);
    }
    string result = "0";
    for(int i = 0; i < a_sz; i++) {
        string curr = "0";
        for(int j = 0; j < b_sz; j++) {
            long long nd = a_bit[i] * b_bit[j];
            //cout << a_bit[i] << " " << b_bit[j] << endl;
            string now = toString(nd);
            for(int k = 0; k < j * 9; k++) {
                now += '0';
            }
            curr = add(now, curr);
        }
        for(int j = 0; j < i * 9; j++) {
            curr += '0';
        }
        result = add(curr, result);
    }
    return strip_zero(result);

}
string power(string a, long long b) {
    string result = "1";
    string curr = a;
    while(b > 0) {
        if(b % 2 == 1) {
            result = multiply(result, curr);
        }
        curr = multiply(curr, curr);
        b /= 2;
    }
    return result;
}
int main() {
    long long t;
    cin >> t;
    for(int p = 0; p < t; p++) {
        long long b, k;
        string a;
        cin >> a >> b >> k;
        string res = power(a, b);
        cout << res[res.size() - k] << endl;
    }

    return 0;
}
