#include <bits/stdc++.h>
using namespace std;
long long del = 1000000000;
string strip_zero(string s) {
    while(s[0] == '0') {
        s.erase(s.begin(), s.begin() + 1);
    }
    return s;
}
string add1(string a, string b) {
    string result = "";
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    int sz;
    if(a.size() > b.size()) {
        sz = a.size();
        int add = sz - b.size();
        for(int i = 0; i < add; i++) {
            b += "0";
        }
    } else {
        sz = b.size();
        int add = sz - a.size();
        for(int i = 0; i < add; i++) {
            a += "0";
        }

    }
    int carry = 0;
    for(int i = 0; i < sz; i++) {
        int curr = (a[i] - '0') + (b[i] - '0') + carry;
        result += '0' + curr % 10;
        carry = curr / 10;
    }
    result += carry + '0';
    reverse(result.begin(), result.end());
    return strip_zero(result);

}

string multiply1(string a, string b) {
    string result = "";
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    if(b.size() > a.size()) {
        swap(a, b);
    }
    int sz = b.size();
    int sz1 = a.size();
    for(int i = 0; i < sz; i++) {
        string curr = "";
        int n = b[i] - '0';
        int carry = 0;
        for(int j = 0; j < sz1; j++) {
            int calc = (a[j] - '0') * n + carry;
            curr += calc % 10 + '0';
            carry = calc / 10;
        }
        curr += carry + '0';
        reverse(curr.begin(), curr.end());
        for(int j = 0; j < i; j++) {
            curr += '0';
        }
        result = add1(result, strip_zero(curr));
    }
    return result;
}
string power1(string a, long long b) {
    string result = "1";
    string curr = a;
    while(b > 0) {
        if(b % 2 == 1) {
            result = multiply1(result, curr);
        }
        curr = multiply1(curr, curr);
        b /= 2;
    }
    return result;
}
string toString(long long n) {
    string s = "";
    while(n > 0) {
        s += '0' + n % 10;
        n /= 10;
    }
    reverse(s.begin(), s.end());
    return s;
}
long long toLL(string s) {
    long long n = 0;
    reverse(s.begin(), s.end());
    long long multiplier = 1;
    for(char c : s) {
        n += (c - '0') * multiplier;
        multiplier *= 10;
    }
    return n;
}
string add(string a, string b, int k) {
    int a_sz = (a.size() % 9 == 0 ? a.size() / 9 : a.size() / 9 + 1);
    int b_sz = (b.size() % 9 == 0 ? b.size() / 9 : b.size() / 9 + 1);
    int la = 9;
    int lb = 9;
    long long a_bit[a_sz];
    long long b_bit[b_sz];
    for(int i = 0; i < a_sz; i++){
        string s1 = "";
        for(int j = a.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += a[j];
            else la--;
        }
        a_bit[i] = toLL(s1);
    }
    for(int i = 0; i < b_sz; i++){
        string s1 = "";
        for(int j = b.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += b[j];
            else lb--;
        }
        b_bit[i] = toLL(s1);
    }
    string result = "";
    int carry = 0;
    if(a_sz > b_sz) {
        for(int i = 0; i < a_sz && i < (k / 9 + 1); i++) {
            long long nd;
            if(i < b_sz)
                nd = a_bit[i] + b_bit[i];
            else
                nd = a_bit[i];
            string add = toString(nd % del + carry);
            while(add.size() != 9) {
                add = '0' + add;
            }
            result = add + result;
            carry = nd > del;
        }
        result = (char)('0' + carry) + result;
    } else {
        for(int i = 0; i < b_sz && i < (k / 9 + 1); i++) {
            long long nd;
            if(i < a_sz) {
                nd = a_bit[i] + b_bit[i];
                //cout << a_bit[i] << " + " << b_bit[i] << " = " << nd << endl;
            }
            else
                nd = b_bit[i];
            string add = toString(nd % del + carry);
            while(add.size() != 9) {
                add = '0' + add;
            }
            //cout << add.size() << endl;
            result = add + result;
            //cout << result << endl;
            carry = nd > del/*nd / (i == b_sz - 1 ? pow(10, max(a_bit[i], b_bit[i])) : del)*/;
        }
        result = (char)('0' + carry) + result;
    }
    return result;
}
string multiply(string a, string b, int k) {
    int a_sz = (a.size() % 9 == 0 ? a.size() / 9 : a.size() / 9 + 1);
    int b_sz = (b.size() % 9 == 0 ? b.size() / 9 : b.size() / 9 + 1);
    int la = 9;
    int lb = 9;
    long long a_bit[a_sz];
    long long b_bit[b_sz];
    for(int i = 0; i < a_sz; i++){
        string s1 = "";
        for(int j = a.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += a[j];
            else la--;
        }
        a_bit[i] = toLL(s1);
    }
    for(int i = 0; i < b_sz; i++){
        string s1 = "";
        for(int j = b.size() - (i + 1) * 9, p = 0; p < 9; p++, j++) {
            if(j >= 0) s1 += b[j];
            else lb--;
        }
        b_bit[i] = toLL(s1);
    }
    string result = "0";
    for(int i = 0; i < a_sz && i < (k / 9 + 1); i++) {
        string curr = "0";
        for(int j = 0; j < b_sz && j < (k / 9 + 1 - j); j++) {
            long long nd = a_bit[i] * b_bit[j];
            //cout << a_bit[i] << " * " << b_bit[j] << " = " << nd << endl;
            string now = toString(nd);
            for(int k = 0; k < j * 9; k++) {
                now += '0';
            }
            curr = add(now, curr, k);
        }
        for(int j = 0; j < i * 9; j++) {
            curr += '0';
        }
        //cout << curr << " + " << result << " = " <<  add(curr, result) << endl;
        result = add(curr, result, k);
    }
    return result;

}
string power(string a, long long b, int k) {
    string result = "1";
    string curr = a;
    while(b > 0) {
        if(b % 2 == 1) {
            result = multiply(result, curr, k);
        }
        curr = multiply(curr, curr, k);
        b /= 2;
    }
    return result;
}
int main() {

    long long t;
    cin >> t;
    for(int p = 0; p < t; p++) {
        long long b, k;
        string a;
        cin >> a >> b >> k;
        string res = power(a, b, k);
        cout << res[res.size() - k] << endl;
    }

    return 0;
}
