#include <bits/stdc++.h>
#define endl '\n'

int n, a, b, l;
long long ans[100001];
std::vector<std::pair<int, int>> conn[100001];

std::pair<long long, int> dfs(int ind, int dist, int parent) {
  std::pair<long long, int> res[100001];
  long long sum = 0;
  int total = 1;
  for (std::pair<int, int> dest : conn[ind]) {
    if (dest.first != parent) {
      res[dest.first] = dfs(dest.first, dist + dest.second, ind);
      total += res[dest.first].second;
      sum += dest.second * res[dest.first].second + res[dest.first].first;
    }
  }
  ans[ind] = 0;
  for (std::pair<int, int> dest : conn[ind]) {
    ans[ind] += dest.second * res[dest.first].second *
                    (total - res[dest.first].second) +
                res[dest.first].first * (total - res[dest.first].second);
  }
  return {sum, total};
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(NULL);
  std::cout.tie(NULL);
  std::cin >> n;
  for (int i = 0; i < n - 1; ++i) {
    std::cin >> a >> b >> l;
    --a;
    --b;
    conn[a].push_back({b, l});
    conn[b].push_back({a, l});
  }
  for (int i = 0; i < n; ++i) {
    dfs(i, 0, -1);
    std::cout << ans[i] << endl;
  }
  return 0;
}
