#include <bits/stdc++.h>
#define endl '\n'
long long a, b, d;
int tests, k;
std::vector<char> num;
std::vector<char> sumRes, multRes, mult1Res, overflow;
void sum(std::vector<char> const *a, std::vector<char> const *b) {
  sumRes.clear();
  int overflow = 0;
  for (size_t i = 0; i < std::min(a->size(), b->size()); ++i) {
    overflow += int((*a)[i]) + int((*b)[i]);
    sumRes.push_back(overflow % 10);
    overflow /= 10;
  }
  for (size_t i = std::min(a->size(), b->size());
       i < std::max(a->size(), b->size()); ++i) {
    if (a->size() > b->size()) {
      sumRes.push_back((*a)[i]);
    } else {
      sumRes.push_back((*b)[i]);
    }
  }
}
void multiply1(std::vector<char> const *n, int a) {
  mult1Res.clear();
  int overflow = 0;
  for (size_t i = 0; i < n->size(); ++i) {
    overflow += int((*n)[i]) * a;
    mult1Res.push_back(overflow % 10);
    overflow /= 10;
  }
}
void multiply(std::vector<char> const *num, std::vector<char> const *mult) {
  multRes.clear();
  for (char i : *mult) {
    multiply1(num, int(i));
    sum(&overflow, &mult1Res);
    overflow = sumRes;
    multRes.push_back(overflow[0]);
    for (size_t j = 0; j < overflow.size() - 1; ++j) {
      std::swap(overflow[j], overflow[j + 1]);
    }
    overflow.pop_back();
  }
}
std::vector<char> fast_pow(std::vector<char> const *a, long long b) {
  if (b == 1) {
    return *a;
  }
  std::vector<char> res = fast_pow(a, b / 2);
  multiply(&res, &res);
  std::vector<char> squared = multRes;
  if (b % 2 == 1) {
    multiply(a, &squared);
    return multRes;
  }
  return squared;
}
int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(NULL);
  num.reserve(1001);
  sumRes.reserve(1001);
  multRes.reserve(1001);
  mult1Res.reserve(1001);
  overflow.reserve(1001);
  std::cin >> tests;
  for (int t = 0; t < tests; ++t) {
    std::cin >> a >> b >> k;
    num.clear();
    for (int i = 0; i < k; ++i) {
      num.push_back(a % 10);
      a /= 10;
    }
    num = fast_pow(&num, b);
    std::cout << int(num[num.size() - 1]) << endl;
  }
  return 0;
}
