#include <stdio.h>
#define MAX_STATIONS 10
short int stations[MAX_STATIONS][MAX_STATIONS];
int previous[MAX_STATIONS];
char inside[MAX_STATIONS];
void memorize(int value, int a)
{
    if(stations[previous[a]][previous[1]] == 0)
    {
        stations[previous[a]][previous[1]] = value * (-1);
        stations[previous[1]][previous[a]] = value * (-1);
    }
    a--;
    while(a > 1)
    {
        stations[previous[a]][0] += value;
        a--;
    }
}
void getInside()
{
    int flag = 0;
    for(int i = 1;i < MAX_STATIONS;i++)
    {
        for (int k = 1; k < MAX_STATIONS & flag < 2; k++) {
            if (stations[i][k] > 0)
                flag++;
        }
        if(flag > 1)
            inside[i] = 1;
        flag = 0;
    }
}
void deleteNode(int n)
{
    for(int i = 0;i < MAX_STATIONS;i++)
    {
        stations[n][i] = 0;
    }
}
int rec_comp(int x, int a, int sum, int m)
{
    int temp = sum, mem;
    for(int i = 1;i < MAX_STATIONS;i++)
    {
        if(stations[i][x] > 0 && stations[x][i] && i != previous[a])
        {
            previous[a+1] = x;
            mem = rec_comp(i, a+1, temp + stations[x][i], m);
            sum += mem;
        }
    }
    previous[a + 1] = x;
    if(mem == 0)
        memorize(temp, a + 1);
    return sum;
}
int compute(int x)
{
    int sum = 0;
    sum = rec_comp(x, 0, 0, inside[x]);
    for(int i = 0;i < MAX_STATIONS;i++)
    {
        if(stations[x][i] < 0)
            sum += stations[x][i] * (-1);
    }
    deleteNode(x);
    return sum;
}
int main()
{
    int N, x, y, n;
    short int l;
    scanf("%d", &N);
    for(int i = 1;i < N;i++)
    {
        scanf("%d %d %hd", &x, &y, &l);
        stations[x][y] = l;
        stations[y][x] = l;
    }
    getInside();
    for(int i = 0;i < N;i++)
        printf("%d", compute(x));
    return 0;
}
