#include <iostream>
#include <vector>
using namespace std;
vector<pair<int, int> > sused[100000];
pair<int, int> busy(int here, int parent, int connection) {
    int paths = 1, sum = 0;
    for (auto curr : sused[here]) {
        if (curr.first == parent) {
            continue;
        }
        pair<int, int> now = busy(curr.first, here, curr.second);
        paths += now.second;
        sum += now.first;
    }
    //cout << here + 1 << " " << parent + 1 << " " << connection << " -> " << sum + connection * paths << " " << paths << '\n';
    return {sum + connection * paths, paths};
}
int main () {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b, l;
        cin >> a >> b >> l;
        a--;
        b--;
        sused[a].push_back({b, l});
        sused[b].push_back({a, l});
    }
    for (int i = 0; i < n; i++) {
        pair<int, int> endings[sused[i].size()];
        int br = 0, sum = 0;
        for (auto curr : sused[i]) {
            endings[br] = busy(curr.first, i, curr.second);
            br++;
        }
        for (int j = 0; j < sused[i].size(); j++) {
            sum += endings[j].first * (n - 1 - endings[j].second + 1);
        }
        cout << sum << '\n';
    }
    return 0;
}
