#include<iostream>
#define endl '\n'
using namespace std;
long long fastumn(long long a,long long b,long long mod)
{
    if(b==1)return a%mod;
    if(b==0)return 0;

    if(b%2==0)
    {
        long long r=fastumn(a,b/2,mod);
        return (r+r)%mod;
    }
    else return (fastumn(a,b-1,mod)+a)%mod;
}
long long step(long long a, long long st)
{
    if(st==0)return 1;
    if(st==1)return a;

    if(st%2==0)
    {
        long long r=step(a,st/2);
        return fastumn(r,r,1000000000000000002);
    }
    else return fastumn(step(a,st-1),a,1000000000000000002);
}
long long step2(long long a, long long st,long long mod)
{
    if(st==0)return 1;
    if(st==1)return a%mod;

    if(st%2==0)
    {
        long long r=step2(a,st/2,mod);
        return fastumn(r,r,mod);
    }
    else return fastumn(step2(a,st-1,mod),a,mod);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long a,b,i,j,k,t;

    cin>>t;

    for(i=1;i<=t;i++)
    {
        cin>>a>>b>>k;

        k=step(10,k);

        a=step2(a,b,k);
        k/=10;

        cout<<a/k<<endl;

    }


}
