#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target("avx,avx2,fma")
#pragma GCC optimization ("unroll-loops")
using namespace std;
const long long maxN=1e5+3,logmx=15;
long long n;
vector<vector<pair<long long,long long> > > v(maxN);
long long jump[maxN][logmx+3], dep[maxN], dist[maxN], br[maxN];
void dfs(long long ind, long long depnw){
    dep[ind]=depnw;
    for(auto to:v[ind]){
        long long t=to.first;
        if(dep[t]==0){
            dist[t]=dist[ind]+to.second;
            dfs(t,depnw+1);
            jump[t][0]=ind;
        }
    }
}
long long lca(long long x, long long y){
    if(dep[x]<dep[y]) swap(x,y);
    long long diff=dep[x]-dep[y];
    for(long long i=0;i<logmx;i++){
        if((1<<i)&diff){
            diff-=(1<<i);
            x=jump[x][i];
            if(diff==0) break;
        }
    }
    if(x==y) return x;
    for(long long i=logmx-1;i>=0;i--){
        if(jump[x][i]!=jump[y][i]){
            x=jump[x][i];
            y=jump[y][i];
        }
    }
    return jump[x][0];
}
int main(){
ios_base::sync_with_stdio(0);
cin.tie(NULL);
cout.tie(NULL);
cin>>n;
for(long long i=1;i<n;i++){
    long long x,y,l; cin>>x>>y>>l;
    x--,y--;
    v[x].push_back({y,l});
    v[y].push_back({x,l});
}
dfs(0,1);
for(long long j=1;j<logmx;j++){
    for(long long i=0;i<n;i++){
        jump[i][j]=jump[jump[i][j-1]][j-1];
    }
}
for(long long i=0;i<n;i++){
    for(long long j=i+1;j<n;j++){
        long long uppst=lca(i,j);
        long long qq=dist[i]+dist[j]-(2*dist[uppst]),cpi=i,cpj=j;
        ///cerr<<"qq";
        while(1){
            br[cpi]+=qq;
            if(cpi==uppst) break;
            cpi=jump[cpi][0];
        }
        while(1){
            if(cpj==uppst) break;
            br[cpj]+=qq;
            cpj=jump[cpj][0];
        }
    }
}
for(long long i=0;i<n;i++) cout<<br[i]<<'\n';
return 0;
}
