#include <bits/stdc++.h>
#pragma GCC optimize("O3")
///#pragma GCC target("avx,avx2,fma")
///#pragma GCC optimization ("unroll-loops")
using namespace std;
const int maxN=1e5+3,logmx=15;
int n;
vector<vector<pair<int,int> > > v(maxN);
int jump[maxN][logmx+3], dep[maxN], dist[maxN], br[maxN];
void dfs(int ind, int depnw){
    dep[ind]=depnw;
    for(auto to:v[ind]){
        int t=to.first;
        if(dep[t]==0){
            dist[t]=dist[ind]+to.second;
            dfs(t,depnw+1);
            jump[t][0]=ind;
        }
    }
}
int lca(int x, int y){
    if(dep[x]<dep[y]) swap(x,y);
    int diff=dep[x]-dep[y];
    for(int i=0;i<logmx;i++){
        if((1<<i)&diff){
            diff-=(1<<i);
            x=jump[x][i];
            if(diff==0) break;
        }
    }
    if(x==y) return x;
    for(int i=logmx-1;i>=0;i--){
        if(jump[x][i]!=jump[y][i]){
            x=jump[x][i];
            y=jump[y][i];
        }
    }
    return jump[x][0];
}
int main(){
ios_base::sync_with_stdio(0);
cin.tie(NULL);
cout.tie(NULL);
cin>>n;
for(int i=1;i<n;i++){
    int x,y,l; cin>>x>>y>>l;
    x--,y--;
    v[x].push_back({y,l});
    v[y].push_back({x,l});
}
dfs(0,1);
for(int j=1;j<logmx;j++){
    for(int i=0;i<n;i++){
        jump[i][j]=jump[jump[i][j-1]][j-1];
    }
}
for(int i=0;i<n;i++){
    for(int j=i+1;j<n;j++){
        int uppst=lca(i,j);
        int qq=dist[i]+dist[j]-(2*dist[uppst]),cpi=i,cpj=j;
        ///cerr<<"qq";
        while(1){
            br[cpi]+=qq;
            if(cpi==uppst) break;
            cpi=jump[cpi][0];
        }
        while(1){
            if(cpj==uppst) break;
            br[cpj]+=qq;
            cpj=jump[cpj][0];
        }
    }
}
for(int i=0;i<n;i++) cout<<br[i]<<'\n';
return 0;
}
