#include<bits/stdc++.h>
using namespace std;

const int maxn=10003;
int n;
vector< pair <int, int> > nbrs[maxn]; //.first ->to, .second -> dist
int depth[maxn];
int parent[maxn];
bool vis[maxn];

int ans[maxn];

int m[maxn][maxn];

void bfs(int x){
	depth[x]=1;
	vis[x]=true;
	queue <int> q;
	q.push(x);

	while(!q.empty()){
		int curr=q.front();
		q.pop();
		for(int i=0; i<nbrs[curr].size(); i++){
			int next=nbrs[curr][i].first;
			if(!vis[next]){
				vis[next]=true;
				parent[nbrs[curr][i].first]=curr;
				depth[next]=depth[curr]+1;
				q.push(next);
			}
		}
	}

	/*for(int i=1; i<=n; i++){
		cerr<<"depth["<<i<<"]="<<depth[i]<<endl<<"parent[i]="<<parent[i]<<endl;
	}*/
}

void path(int x, int y){
	int sum=0;
	vector<int> p;
	p.push_back(x);
	p.push_back(y);
	while(x!=y){
		if(depth[x]<depth[y]){
			//cerr<<y<<" to "<<parent[y]<<" add "<<m[y][parent[y]]<<endl;
			sum+=m[y][parent[y]];
			y=parent[y];
			p.push_back(y);
		}else{
			if(depth[x]>depth[y]){
				//cerr<<x<<" to "<<parent[x]<<" add "<<m[x][parent[x]]<<endl;
				sum+=m[x][parent[x]];
				x=parent[x];
				p.push_back(x);
			}else{
				if(depth[x]==depth[y] and x!=y){
					//cerr<<x<<" to "<<parent[x]<<" add "<<m[x][parent[x]]<<endl;
					//cerr<<y<<" to "<<parent[y]<<" add "<<m[y][parent[y]]<<endl;
					sum+=m[x][parent[x]];
					sum+=m[y][parent[y]];
					x=parent[x];
					y=parent[y];
					p.push_back(x);
			        	p.push_back(y);
				}
			}
		}
	}
	//cerr<<sum<<endl;
	for(int i=0; i<p.size()-1; i++){
		//cerr<<p[i]<<" ";
		ans[p[i]]+=sum;	
	}
	//cerr<<endl;

	return ;
}

int main (){
ios_base::sync_with_stdio(false);
cin.tie(NULL);

cin>>n;
for(int i=0; i<n-1; i++){
	int a, b, l;
	cin>>a>>b>>l;
	nbrs[a].push_back({b, l});
	nbrs[b].push_back({a, l});
	m[a][b]=l;
	m[b][a]=l;
}

/*
for(int i=1; i<=n; i++){
	for(int j=1; j<=n; j++){
		cerr<<m[i][j]<<" ";
	}
	cerr<<endl;
}
*/

bfs(1);

for(int i=1; i<=n; i++){
	for(int j=i+1; j<=n; j++){
		//cerr<<"from "<<i<<" to "<<j<<endl;
		path(i, j);
	}
}

for(int i=1; i<=n; i++){
	cout<<ans[i]<<endl;
}
return 0;
}