#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 1e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n;
ll sub[maxn], path_sum[maxn], ans[maxn];
vector < pair < int, ll > > g[maxn];

void pre_calc(int ver, int par)
{
    sub[ver] = 1;
    for (int i = 0; i < g[ver].size(); i ++)
    {
        int u = g[ver][i].first;
        if (u == par)
            continue;
        pre_calc(u, ver);
        sub[ver] += sub[u];
        path_sum[ver] = path_sum[ver] + path_sum[u] + sub[u] * g[ver][i].second;
    }
}

void dfs(int ver, int par, ll above)
{
    ///cout << ver << " - " << par << " - " << above << " " << path_sum[ver] << endl;
    ans[ver] = ans[ver] + above * sub[ver];
    for (int i = 0; i < g[ver].size(); i ++)
    {
        int u = g[ver][i].first;
        if (u == par)
            continue;
        ll here = n - sub[u];
        ll go_down = above + path_sum[ver] - path_sum[u] + (here - sub[u]) * g[ver][i].second;
        dfs(u, ver, go_down);
        ans[ver] = ans[ver] + (path_sum[u] + sub[u] * g[ver][i].second) * here;
    }

}
void solve()
{
    cin >> n;

    int v, u;
    ll w;
    for (int i = 1; i < n; i ++)
    {
        cin >> v >> u >> w;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    pre_calc(1, -1);
    dfs(1, -1, 0);
    for (int i = 1; i <= n; i ++)
        cout << ans[i] << endl;
}

int main ()
{
    speed();
    solve();
    return 0 ;
}
