#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


ll small_power(ll a, ll b)
{
    ll ans = 1;
    while(b > 0)
    {
        if (b % 2 == 1)
            ans = ans * a;
        a = a * a;
        b /= 2;
    }
    return ans;
}
ll a, b, k;

vector < int > add(vector < int > v1, vector < int > v2)
{
    vector < int > res;
    int p = 0;
    for (int i = 0; i < max(v1.size(), v2.size()) && res.size() < k; i ++)
    {
        int c1 = 0, c2 = 0;
        if ((int)v1.size() > i)
            c1 = v1[i];
        if ((int)v2.size() > i)
            c2 = v2[i];

        int s = c1 + c2 + p;
        p = s / 10;
        if (s >= 10)
            s -= 10;
        res.push_back(s);
    }
    if (p != 0 && res.size() < k)
        res.push_back(p);
    return res;
}

vector < int > add_zero(vector < int > v1, int cnt)
{
    vector < int > res;
    for (int i = 0; i < cnt; i ++)
        res.push_back(0);

    for (int i = 0; i < v1.size() && res.size() < k; i ++)
    {
        res.push_back(v1[i]);
    }
    return res;
}

vector < int > multiply(vector < int > v1, vector < int > v2)
{
    vector < int > rl[10];

    rl[1] = v1;

    for (int i = 2; i < 10; i ++)
        rl[i] = add(rl[i - 1], v1);


    vector < int > res;
    for (int i = 0; i < min(k, (ll)v2.size()); i ++)
    {
        res = add(res, add_zero(rl[v2[i]], i));
    }

    return res;
}
vector < int > power(vector < int > base, ll st)
{

    vector < int > ans;
    ans.push_back(1);
    while(st > 0)
    {

        if (st % 2 == 1)
            ans = multiply(ans, base);
        base = multiply(base, base);
        st /= 2;
    }
    return ans;
}


void solve()
{
    cin >> a >> b >> k;
    ll save_k = k;
    k = k + 10;
    //cout << small_power(a, b) << endl;
    vector < int > mult;
    while(a > 0 && mult.size() < k)
    {
        mult.push_back(a % 10);
        a /= 10;
    }
    vector < int > ans = power(mult, b);
    cout << ans[save_k - 1] << endl;

}

int main ()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
